package Iterators;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Iterator;
import java.util.NoSuchElementException;
import java.util.Vector;
import basicas.Cliente;
import basicas.Endereco;
import basicas.Telefone;

public class IteratorCliente implements Iterator<Cliente> {

	private Vector<Cliente> resultado;
	private int indice;
	
	public IteratorCliente(ResultSet resultSet) throws NumberFormatException, SQLException{
		resultado = new Vector<Cliente>();
		indice = 0;
		while(resultSet.next()){
			Cliente cliente = new Cliente(resultSet.getString("nome"), resultSet.getString("email"),
										resultSet.getString("cpf"), ((Endereco)resultSet.getObject("endereco")),
										((Vector<Telefone>)resultSet.getObject("telefone")));
			cliente.setNumeroDeCadastro(Integer.parseInt(resultSet.getString("numero")));
			resultado.add(cliente);
		}
	}
	
	public boolean hasNext() {
		return indice < resultado.size();
	}

	public Cliente next() {
		indice++;
		return resultado.get(indice - 1);
	}

	public void remove() {
	}

}
