package gui;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

@SuppressWarnings("serial")
public class JanelaAdm extends JFrame {

    private PanelInicial panelInicial;
    
    private PanelConsultar panelConsultar;
    private PanelGerarRelatorio panelGerarRelatorio;
    private PanelCadastrar panelCadastrar;
   
    private PanelCadastroDeCliente panelCadastrarCliente;
    private PanelCadastroDeDepartamento panelCadastrarDepartamento;
    private PanelCadastroDeFuncionario panelCadastrarFuncionario;
    private PanelCadastroDeModelo panelCadastrarModelo;
    private PanelCadastroDeServico panelCadastrarServico;
    private PanelCadastroDeVeiculo panelCadastrarVeiculo;

    public JanelaAdm() {
        this.setTitle("GSA - Administrador");

        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
        }

        this.setSize(800, 545);
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        // centraliza a janela
        this.setLocationRelativeTo(null);
        this.setResizable(false);
        this.initComponents();
        this.setVisible(true);

    }

    private void initComponents() {

        //configurando PanelIncial
        this.panelInicial = new PanelInicial() {
            @Override
            public void clicouConsultar() {
                eventoConsultar();
            }

            @Override
            public void clicouGerarRelatorio() {
                eventoGerarRelatorio();
            }

            @Override
            public void clicouCadastrar() {
                eventoCadastrar();
            }
        };
        this.panelInicial.setSize(this.getWidth(), this.getHeight());
        this.panelInicial.setLocation(0, 0);

        //Configurando Panel Cadastrar
        this.panelCadastrar = new PanelCadastrar() {
            @Override
            public void clicouVoltar() {
                eventoVoltar();
            }

            @Override
            public void clicouOK() {
                eventoEscolheuCadastro();
            }
        };

        //Configurando Panel Consultar
        this.panelConsultar = new PanelConsultar() {
            @Override
            public void clicouVoltar() {
                eventoVoltar();
            }
        };

        //Configrando panel Gerar Relatorio
        this.panelGerarRelatorio = new PanelGerarRelatorio(){
            @Override
            public void clicouVoltar() {
                eventoVoltar();
            }
            
        };

        //criar panels cadastrar
        this.panelCadastrarCliente = new PanelCadastroDeCliente(){
            @Override
            public void clicouVoltar() {
                eventoVoltar();
            }
        };

        this.panelCadastrarDepartamento = new PanelCadastroDeDepartamento(){
            @Override
            public void clicouVoltar() {
                eventoVoltar();
            }
        };

        this.panelCadastrarFuncionario = new PanelCadastroDeFuncionario(){
            @Override
            public void clicouVoltar() {
                eventoVoltar();
            }
        };

        this.panelCadastrarModelo = new PanelCadastroDeModelo(){
            @Override
            public void clicouVoltar() {
                eventoVoltar();
            }
        };

        this.panelCadastrarServico = new PanelCadastroDeServico(){
            @Override
            public void clicouVoltar() {
                eventoVoltar();
            }
        };
        this.panelCadastrarVeiculo = new PanelCadastroDeVeiculo(){
            @Override
            public void clicouVoltar() {
                eventoVoltar();
            }
        };

        
        this.add(this.panelInicial);
    }

    private void escolheuCadastrarCliente() {
        setTitle("GSA - Administrador (Cadastro de Cliente)");
        this.setContentPane(this.panelCadastrarCliente);
        SwingUtilities.updateComponentTreeUI(this);
    }

    private void escolheuCadastrarFuncionario() {
        setTitle("GSA - Administrador (Cadastro de Funcionrio)");
        this.setContentPane(this.panelCadastrarFuncionario);
        SwingUtilities.updateComponentTreeUI(this);

    }

    private void escolheuCadastrarDepartamento() {
        setTitle("GSA - Administrador (Cadastro de Departamento)");
        this.setContentPane(this.panelCadastrarDepartamento);
        SwingUtilities.updateComponentTreeUI(this);

    }

    private void escolheuCadastrarServico() {
        setTitle("GSA - Administrador (Cadastro de Servio)");
        this.setContentPane(this.panelCadastrarServico);
        SwingUtilities.updateComponentTreeUI(this);

    }

    private void escolheuCadastrarModelo() {
        setTitle("GSA - Administrador (Cadastro de Modelo)");
        this.setContentPane(this.panelCadastrarModelo);
        SwingUtilities.updateComponentTreeUI(this);

    }

    private void escolheuCadastrarVeiculo() {
        setTitle("GSA - Administrador (Cadastro de Veculo)");
        this.setContentPane(this.panelCadastrarVeiculo);
        SwingUtilities.updateComponentTreeUI(this);
    }

    private void eventoGerarRelatorio() {
        setTitle("GSA - Administrador (Gerar Relatrio)");
        this.setContentPane(this.panelGerarRelatorio);
        SwingUtilities.updateComponentTreeUI(this);

    }

    private void eventoConsultar() {
        setTitle("GSA - Administrador (Consultar)");
        this.setContentPane(this.panelConsultar);
        SwingUtilities.updateComponentTreeUI(this);

    }

    private void eventoCadastrar() {
        this.panelInicial.add(panelCadastrar);
        SwingUtilities.updateComponentTreeUI(this);
    }

    private void eventoVoltar() {
        this.panelInicial.remove(panelCadastrar);
        this.setContentPane(panelInicial);
        this.setTitle("GSA - Administrador");
        SwingUtilities.updateComponentTreeUI(this);
    }

    private void eventoEscolheuCadastro() {
        if (panelCadastrar.getSelecioando().equals("Cliente")) {
            escolheuCadastrarCliente();
        } else if (panelCadastrar.getSelecioando().equals("Departamento")) {
            escolheuCadastrarDepartamento();
        } else if (panelCadastrar.getSelecioando().equals("Funcionrio")) {
            escolheuCadastrarFuncionario();
        } else if (panelCadastrar.getSelecioando().equals("Modelo")) {
            escolheuCadastrarModelo();
        } else if (panelCadastrar.getSelecioando().equals("Servio")) {
            escolheuCadastrarServico();
        } else if (panelCadastrar.getSelecioando().equals("Veculo")) {
            escolheuCadastrarVeiculo();
        }
    }
}
