package gui;

import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.sql.SQLException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import javax.swing.UIManager;

import execoes.DadoInexistenteException;
import fachada.Fachada;

@SuppressWarnings("serial")
public class JanelaLogin extends JFrame {

    //Declarando Atributos
    private JButton botaoEntrar;
    
    private JTextField campoCadastro;
    private JPasswordField campoSenha;
    
    private JLabel rotuloCadastro;
    private JLabel rotuloSenha;
    
    private Fachada fachada;
    
    public JanelaLogin() {
        //Configuracoes da Janela
        setTitle("GSA - Entrar"); //nome da janela
        setSize(290, 150); //dimensoes
        setLayout(null); //layout
        setLocationRelativeTo(null); //janela abrir no centro da tela
        setResizable(false); //nao pode alterar o tamanho da janela
        setDefaultCloseOperation(EXIT_ON_CLOSE); //encerra o programa se a janela for fechada
        try {
            //look and feel do sistema operacional
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {}

		try {
			fachada = Fachada.getInstace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
        //Inicializando Atributos
        rotuloCadastro = new JLabel();
        rotuloSenha = new JLabel();
        campoCadastro = new JTextField();
        campoSenha = new JPasswordField();
        botaoEntrar = new JButton();
        
        //Configurando rotuloCadastro
        rotuloCadastro.setText("Cadastro:");
        rotuloCadastro.setFont(new Font("Courier New", Font.BOLD, 24));
        rotuloCadastro.setLocation(20, 20);
        rotuloCadastro.setSize(130, 20);

        //Configurando rotuloSenha
        rotuloSenha.setText("Senha:");
        rotuloSenha.setFont(new Font("Courier New", Font.BOLD, 24));
        rotuloSenha.setLocation(60, 50);
        rotuloSenha.setSize(86, 20);
        
        //Configurando campoCadastro
        campoCadastro.setToolTipText("Digite aqui o seu numero de cadastro");
        campoCadastro.setLocation(160, 20);
        campoCadastro.setSize(100, 20);
       
        //Configurando campoSenha
        campoSenha.setToolTipText("Digite aqui sua senha");
        campoSenha.setLocation(160, 50);
        campoSenha.setSize(100, 20);
           
        //Configurando botaoEntrar
        botaoEntrar.setText("Entrar");
        botaoEntrar.setToolTipText("Clique aqui para entrar");
        botaoEntrar.setLocation(160, 80);
        botaoEntrar.setSize(100, 30);
        botaoEntrar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evento) {
                clicouEntrar();
            }
        });

        //Quando o usuario tecla enter  chamado o clicouEntrar
        this.inserirEnventoEnter();
        
        //Adicionar os componentes na janela
        add(rotuloCadastro);
        add(rotuloSenha);
        add(campoCadastro);
        add(campoSenha);
        add(botaoEntrar);

        //mostrar a janela
        setVisible(true);
    }

    // Aqui est o codigo do evento do botaoEntrar
    private void clicouEntrar() {
    	/*try {
    		int cadastro = Integer.parseInt(campoCadastro.getText());
    		String senha = String.copyValueOf(campoSenha.getPassword());
            
            boolean logou = fachada.efetuarLogin(cadastro, senha);
            
            if (logou) {*/
            	dispose();
            	new JanelaAdm();
           /* } else {
            	JOptionPane.showMessageDialog(null, "Senha Incorreta", "Erro", JOptionPane.ERROR_MESSAGE);
                campoCadastro.setText(""); //limpar campo cadastro
                campoSenha.setText(""); //limpar campo senha
            }     
            
    	} catch (NumberFormatException e) {
    		JOptionPane.showMessageDialog(null, "Formato do Cadastro Invlido", "Erro", JOptionPane.ERROR_MESSAGE);
    	} catch (DadoInexistenteException e) {
    		JOptionPane.showMessageDialog(null, e.getMessage(), "Erro", JOptionPane.ERROR_MESSAGE);
		}  */       
    }

    /*Metodo que faz com que quando o usuario clique enter  chamado o evento
     de clicouEntrar*/
    private void inserirEnventoEnter() {
        KeyAdapter enterPress = new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent evento) {
                if (evento.getKeyCode() == KeyEvent.VK_ENTER) {
                    clicouEntrar();
                }
            }
        };
        campoSenha.addKeyListener(enterPress);
        campoCadastro.addKeyListener(enterPress);
        botaoEntrar.addKeyListener(enterPress);
    }

    public static void main(String args[]) {
        EventQueue.invokeLater(new Runnable() {
            public void run() {
                new JanelaLogin();
            }
        });
    }      
}

