package gui;

import java.awt.BorderLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.sql.SQLException;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

import execoes.CamposObrigatoriosException;
import fachada.Fachada;

@SuppressWarnings("serial")
public class PanelCadastroDeDepartamento extends JPanel {

	private JPanel painel1;

	private JButton botaoCadastrar;
	private JButton botaoLimpar;
    private JButton botaoVoltar;

	private JLabel nome;
	private JLabel local;
	private JLabel numeroDeContratoDoGerente;

	private JTextField campoNome;
	private JTextField campoLocal;
	private JTextField campoNumeroDeContratoDoGerente;
    
	private Fachada fachada;

	public PanelCadastroDeDepartamento() {

		this.setLayout(null);

		try {
			fachada = Fachada.getInstace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		TitledBorder title;

		this.painel1 = new JPanel(null);
		title = BorderFactory.createTitledBorder("Departamento");
		painel1.setBorder(title);
		painel1.setBounds(30, 20, 600, 225);
		this.add(painel1, BorderLayout.CENTER);

		initComponentesFuncionario();

	}

	private void initComponentesFuncionario() {

		this.botaoCadastrar = new JButton("Cadastrar");
		this.botaoLimpar = new JButton("Limpar");
        this.botaoVoltar = new JButton();

		
		this.nome = new JLabel("Nome:");

		this.local = new JLabel("Local:");
		this.numeroDeContratoDoGerente = new JLabel("Nmero de Contrato do Gerente:");

		
		this.campoNome = new JTextField();
		this.campoLocal = new JTextField();
		this.campoNumeroDeContratoDoGerente = new JTextField();

		this.nome.setBounds(30, 25, 150, 20);
		this.campoNome.setBounds(30, 50, 260, 20);

		this.local.setBounds(30, 80, 40, 20);
		this.campoLocal.setBounds(30, 105, 260, 20);

		this.numeroDeContratoDoGerente.setBounds(30, 135, 160, 20);
		this.campoNumeroDeContratoDoGerente.setBounds(30, 160, 260, 20);

		this.painel1.add(this.nome);
		this.painel1.add(this.campoNome);
		this.painel1.add(this.local);
		this.painel1.add(this.campoLocal);
		this.painel1.add(this.numeroDeContratoDoGerente);
		this.painel1.add(this.campoNumeroDeContratoDoGerente);

		this.botaoCadastrar.setBounds(640, 25, 100, 25);
		
		botaoCadastrar.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent evt) {
				try {
					clicouCadastrar();
				} catch (CamposObrigatoriosException e) {
					JOptionPane.showMessageDialog(null, e.getMensagem(), "Erro", JOptionPane.ERROR_MESSAGE);
				} catch (Exception e){
					JOptionPane.showMessageDialog(null, "Verifique se todas as entradas esto no formato correto", "Erro", JOptionPane.ERROR_MESSAGE);
				}
			}
		});
		
		this.botaoLimpar.setBounds(640, 70, 100, 25);
		botaoLimpar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evt) {
                clicouLimpar();
            }
        });

        botaoVoltar.setIcon(new ImageIcon("back.png"));
        botaoVoltar.setBounds(750, 25, 32, 32);
        botaoVoltar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evt) {
                clicouVoltar();
            }
        });
        

		this.add(this.botaoCadastrar);
		this.add(this.botaoLimpar);
        this.add(botaoVoltar);

	}



    public void clicouVoltar() {
        //metodo deve ser reemplmentado
    }

    private void clicouCadastrar() throws CamposObrigatoriosException {
    	
        String nome = campoNome.getText();
        String local = campoLocal.getText();
        int numeroDeContratoDoGerente = Integer.parseInt(campoNumeroDeContratoDoGerente.getText());

        if(fachada.cadastrarDepartamento(nome, local, numeroDeContratoDoGerente)){
        	JOptionPane.showMessageDialog(null, "Operao realizada com sucesso", "Sucesso", JOptionPane.OK_OPTION);
	    }else{
			JOptionPane.showMessageDialog(null, "A operao no pode ser concluida, tente novamente", "Erro", JOptionPane.ERROR_MESSAGE);
		}
    }
    
    private void clicouLimpar () {
    	campoNome.setText("");
    	campoLocal.setText("");
    	campoNumeroDeContratoDoGerente.setText("");
    }
    
}
