package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.sql.SQLException;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

import execoes.CamposObrigatoriosException;
import execoes.DadoInexistenteException;
import execoes.FormatoDataInvalidoException;
import fachada.Fachada;

import basicas.Endereco;
import basicas.Telefone;

@SuppressWarnings("serial")
public class PanelCadastroDeFuncionario extends JPanel {

    private JPanel panelFuncionario;
    private PanelEndereco painelEndereco;
    
    private JButton botaoCadastrar;
    private JButton botaoLimpar;
    private JButton botaoVoltar;    
   
    private JLabel nome;
    private JLabel dataNascimento;
    private JLabel cpf;
    private JLabel rg;
    private JLabel cargo;
    private JLabel salario;
    private JLabel numeroDoDepartamento;
    private JLabel labelSenha;
    
    private JTextField campoNome;
    private JTextField campoCpf;
    private JTextField campoRg;
    private JTextField campoCargo;
    private JTextField campoSalario;
    private JTextField campoNumeroDoDepartamento;
    private JPasswordField campoSenha;
    
    private JLabel barra1DataNascimento;
    private JLabel barra2DataNascimento;
    
    private JTextField diaDataNascimento;
    private JTextField mesDataNascimento;
    private JTextField anoDataNascimento;
    
    private PanelLista panelTelefone;    

    private Fachada fachada;

    public PanelCadastroDeFuncionario() {

        this.setLayout(null);

        try {
			fachada = Fachada.getInstace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        
        TitledBorder title;

        this.panelFuncionario = new JPanel(null);
        title = BorderFactory.createTitledBorder("Funcionrio");
        panelFuncionario.setBorder(title);
        panelFuncionario.setBounds(30, 20, 600, 480);
        this.add(panelFuncionario, BorderLayout.CENTER);


        painelEndereco = new PanelEndereco();
        panelFuncionario.add(painelEndereco);

        initComponentesFuncionario();

    }

    private void initComponentesFuncionario() {

        this.botaoCadastrar = new JButton("Cadastrar");
        this.botaoLimpar = new JButton("Limpar");
        this.botaoVoltar = new JButton();
   
        this.nome = new JLabel("Nome:");
        this.dataNascimento = new JLabel("Data de nascimento:");
        this.cpf = new JLabel("CPF:");
        this.rg = new JLabel("RG:");
        this.cargo = new JLabel("Cargo:");
        this.salario = new JLabel("Salario:");
        this.numeroDoDepartamento = new JLabel("Nmero do departamento:");
        this.labelSenha = new JLabel("Senha:");
        
        this.barra1DataNascimento = new JLabel("/");
        this.barra2DataNascimento = new JLabel("/");

        this.campoNome = new JTextField();
        this.diaDataNascimento = new JTextField();
        this.mesDataNascimento = new JTextField();
        this.anoDataNascimento = new JTextField();
        this.campoCpf = new JTextField();
        this.campoRg = new JTextField();
        this.campoCargo = new JTextField();
        this.campoSalario = new JTextField();
        this.campoNumeroDoDepartamento = new JTextField();
        this.campoSenha = new JPasswordField();

        this.panelTelefone = new PanelLista("Telefone:");

        this.nome.setBounds(30, 25, 40, 20);
        this.campoNome.setBounds(30, 50, 260, 20);

        this.cpf.setBounds(30, 80, 40, 20);
        this.campoCpf.setBounds(30, 105, 260, 20);

        this.rg.setBounds(30, 135, 40, 20);
        this.campoRg.setBounds(30, 160, 260, 20);

        this.dataNascimento.setBounds(30, 190, 105, 20);
        this.diaDataNascimento.setBounds(30, 215, 25, 20);
        this.barra1DataNascimento.setBounds(65, 215, 5, 20);
        this.mesDataNascimento.setBounds(75, 215, 25, 20);
        this.barra2DataNascimento.setBounds(110, 215, 5, 20);
        this.anoDataNascimento.setBounds(120, 215, 35, 20);
        
        this.cargo.setBounds(30, 245, 40, 20);
        this.campoCargo.setBounds(30, 270, 260, 20);
        
        this.salario.setBounds(30, 300, 40, 20);
        this.campoSalario.setBounds(30, 325, 260, 20);
        
        this.numeroDoDepartamento.setBounds(30, 355, 150, 20);
        this.campoNumeroDoDepartamento.setBounds(30, 380, 260, 20);
        
        this.labelSenha.setForeground(Color.RED);
        this.labelSenha.setBounds(30, 410, 80, 20);
        this.campoSenha.setBounds(30, 435, 260, 20);
        
        this.panelTelefone.setBounds(320, 350, 270, 85);
        
        this.panelFuncionario.add(this.nome);
        this.panelFuncionario.add(this.campoNome);
        this.panelFuncionario.add(this.cpf);
        this.panelFuncionario.add(this.campoCpf);
        this.panelFuncionario.add(this.rg);
        this.panelFuncionario.add(this.campoRg);
        this.panelFuncionario.add(this.cargo);
        this.panelFuncionario.add(this.campoCargo);
        this.panelFuncionario.add(this.salario);
        this.panelFuncionario.add(this.campoSalario);
        this.panelFuncionario.add(this.numeroDoDepartamento);
        this.panelFuncionario.add(this.campoNumeroDoDepartamento);
        this.panelFuncionario.add(this.dataNascimento);
        this.panelFuncionario.add(this.diaDataNascimento);
        this.panelFuncionario.add(this.barra1DataNascimento);
        this.panelFuncionario.add(this.mesDataNascimento);
        this.panelFuncionario.add(this.barra2DataNascimento);
        this.panelFuncionario.add(this.anoDataNascimento);
        this.panelFuncionario.add(this.labelSenha);
        this.panelFuncionario.add(this.campoSenha);
        this.panelFuncionario.add(this.panelTelefone);

        this.botaoCadastrar.setBounds(640, 25, 100, 25);
        botaoCadastrar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evt) {
                try {
					clicouCadastrar();
				} catch (CamposObrigatoriosException e) {
					JOptionPane.showMessageDialog(null, e.getMensagem(), "Erro", JOptionPane.ERROR_MESSAGE);
				} catch (DadoInexistenteException e) {
					JOptionPane.showMessageDialog(null, e.getMensagem(), "Erro", JOptionPane.ERROR_MESSAGE);
				} catch (FormatoDataInvalidoException e){
					JOptionPane.showMessageDialog(null, e.getMensagem(), "Erro", JOptionPane.ERROR_MESSAGE);
				} catch (Exception e){
					JOptionPane.showMessageDialog(null, "Verifique se todas as entradas esto no formato correto", "Erro", JOptionPane.ERROR_MESSAGE);
				}
            }
        });
        
        botaoVoltar.setIcon(new ImageIcon("back.png"));
        botaoVoltar.setBounds(750, 25, 32, 32);
        botaoVoltar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evt) {
                clicouVoltar();
            }
        });

        
        this.botaoLimpar.setBounds(640, 70, 100, 25);
        botaoLimpar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evt) {
                clicouLimpar();
            }
        });
     
        this.add(this.botaoCadastrar);
        this.add(this.botaoLimpar);
        this.add(this.botaoVoltar);

    }
    
    public void clicouVoltar() {
    	
    }

    private void clicouCadastrar() throws CamposObrigatoriosException, DadoInexistenteException, FormatoDataInvalidoException {
    	
        String nome = campoNome.getText();
        String cpf = campoCpf.getText();
        String rg = campoRg.getText();
        String cargo = campoCargo.getText();
        double salario = Double.parseDouble(campoSalario.getText());
        int numeroDepartamento = Integer.parseInt(campoNumeroDoDepartamento.getText());
        String senha = String.copyValueOf(campoSenha.getPassword());
        
        String dia = diaDataNascimento.getText();
        String mes = mesDataNascimento.getText();
        String ano = anoDataNascimento.getText();
        
        if(dia.length() != 2 || mes.length() != 2 || ano.length() != 4)
        	throw new FormatoDataInvalidoException();
        
        String dataDeNascimento = dia + "/" + mes + "/" + ano;
        
        Endereco endereco = painelEndereco.getEndereco();
        
        Vector<String> lista = panelTelefone.getLista();
        Vector<Telefone> telefones = new Vector<Telefone>();
        for (int i = 0; i < lista.size(); i++) {
        	telefones.add(new Telefone(lista.get(i)));
        }
        
        if(fachada.cadastrarFuncionario(nome, senha, dataDeNascimento, cpf, rg, cargo, salario, numeroDepartamento, endereco, telefones)){
        	JOptionPane.showMessageDialog(null, "Operao realizada com sucesso", "Sucesso", JOptionPane.OK_OPTION);
	    }else{
			JOptionPane.showMessageDialog(null, "A operao no pode ser concluida, tente novamente", "Erro", JOptionPane.ERROR_MESSAGE);
		}
    }
    
    private void clicouLimpar() {
    	campoNome.setText("");
    	campoCpf.setText("");
    	campoRg.setText("");
    	campoCargo.setText("");
    	campoSalario.setText("");
    	campoNumeroDoDepartamento.setText("");
    	campoSenha.setText("");
    	diaDataNascimento.setText("");
    	mesDataNascimento.setText("");
    	anoDataNascimento.setText("");
    	painelEndereco.limparCampos();
    	panelTelefone.limparLista();
    }
    
    
}
