package gui;

import java.awt.BorderLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.sql.SQLException;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

import fachada.Fachada;
import execoes.CamposObrigatoriosException;

@SuppressWarnings("serial")
public class PanelCadastroDeModelo extends JPanel {

    private JPanel painel1;
    
    private JButton botaoCadastrar;
    private JButton botaoLimpar;
    private JButton botaoVoltar;
    private JButton botaoProcurarFoto;
    
    private JLabel marca;
    private JLabel modelo;
    private JLabel rotuloFoto;
    
    private JTextField campoUrlFoto;
    private JTextField campoMarca;
    private JTextField campoModelo;
    
    private Fachada fachada;

    public PanelCadastroDeModelo() {

        this.setLayout(null);

        try {
			fachada = Fachada.getInstace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        
        TitledBorder title;

        this.painel1 = new JPanel(null);
        title = BorderFactory.createTitledBorder("Modelo");
        painel1.setBorder(title);
        painel1.setBounds(30, 20, 600, 210);
        this.add(painel1, BorderLayout.CENTER);

        initComponentesFuncionario();

    }

    private void initComponentesFuncionario() {

        this.botaoCadastrar = new JButton("Cadastrar");
        this.botaoLimpar = new JButton("Limpar");
        this.botaoVoltar = new JButton();
        this.botaoProcurarFoto = new JButton("Arquivo");
        
        this.marca = new JLabel("Marca:");
        this.modelo = new JLabel("Modelo:");
        this.rotuloFoto = new JLabel("Foto:");
        
        this.campoMarca = new JTextField();
        this.campoModelo = new JTextField();
        this.campoUrlFoto = new JTextField();
    
        this.marca.setBounds(30, 25, 40, 20);
        this.campoMarca.setBounds(30, 50, 260, 20);
        
        this.modelo.setBounds(30, 80, 40, 20);
        this.campoModelo.setBounds(30, 105, 260, 20);
               
        this.rotuloFoto.setBounds(30, 135, 40, 20);
        this.campoUrlFoto.setBounds(30, 160, 190, 20);
        this.campoUrlFoto.setEditable(false);
        this.botaoProcurarFoto.setBounds(220, 160, 70, 23);
        botaoProcurarFoto.addMouseListener(new MouseAdapter() {
            @Override
        public void mouseClicked(MouseEvent evt) {
                clicouArquivo();
            }
        });
        
        this.painel1.add(this.marca);
        this.painel1.add(this.campoMarca);
        this.painel1.add(this.modelo);
        this.painel1.add(this.campoModelo);
        this.painel1.add(this.rotuloFoto);
        this.painel1.add(this.campoUrlFoto);
        this.painel1.add(this.botaoProcurarFoto);


        this.botaoCadastrar.setBounds(640, 25, 100, 25);
        botaoCadastrar.addMouseListener(new MouseAdapter() {
        @Override
        public void mouseClicked(MouseEvent evt) {
                try {
					clicouCadastrar();
				} catch (CamposObrigatoriosException e) {
					JOptionPane.showMessageDialog(null, e.getMensagem(), "Erro", JOptionPane.ERROR_MESSAGE);
				}
            }
        });
        
        this.botaoLimpar.setBounds(640, 70, 100, 25);
        botaoLimpar.addMouseListener(new MouseAdapter() {
            @Override
        public void mouseClicked(MouseEvent evt) {
                clicouLimpar();
            }
        });
        
        botaoVoltar.setIcon(new ImageIcon("back.png"));
        botaoVoltar.setBounds(750, 25, 32, 32);
        botaoVoltar.addMouseListener(new MouseAdapter() {
            @Override
        public void mouseClicked(MouseEvent evt) {
                clicouVoltar();
            }
        });

        this.add(this.botaoCadastrar);
        this.add(this.botaoLimpar);
        this.add(this.botaoVoltar);

    }

    public void clicouVoltar() {
        //metodo deve ser reemplmentado
    }
    
    public void clicouCadastrar() throws CamposObrigatoriosException{
 	   String marca = campoMarca.getText();
 	   String modelo = campoModelo.getText();
 	   String foto =  campoUrlFoto.getText();
 	   
 	   if(fachada.cadastrarModelo(marca, modelo)){
 			JOptionPane.showMessageDialog(null, "Operao realizada com sucesso", "Sucesso", JOptionPane.OK_OPTION);
 	   }else{
			JOptionPane.showMessageDialog(null, "A operao no pode ser concluida, tente novamente", "Erro", JOptionPane.ERROR_MESSAGE);
		}
 }
    
    private void clicouArquivo() {
    	JFileChooser escolherArquivo = new JFileChooser();
       	escolherArquivo.setApproveButtonText("Abrir");
       	int resultado = escolherArquivo.showOpenDialog(null);
       	    	
    	if (resultado == JFileChooser.APPROVE_OPTION) {
    		String url = escolherArquivo.getSelectedFile().getAbsolutePath();
    		
    		boolean extensaoPermitida = extensaoEhPermitido(url);
    		
    		if (extensaoPermitida) {
    			campoUrlFoto.setText(url);
    		} else {
    			JOptionPane.showMessageDialog(null, "Extenso do arquivo invlido!", "Erro", JOptionPane.ERROR_MESSAGE);
    		}
    	}	
    	
    }

	private boolean extensaoEhPermitido(String url) {
		String[] formatosPermitidos = new String[] {
			".jpg", ".png", ".bmp", ".jpeg"	
		};
		
		boolean achou = false;
		int i = 0;
		while (!achou && i < 4) {
			
			if (url.endsWith(formatosPermitidos[i])) {
				achou = true;
			} else {
				i = i + 1;
			}    			
		}
		return achou;
	}
    
    private void clicouLimpar() {
    	campoMarca.setText("");
    	campoModelo.setText("");
    	campoUrlFoto.setText("");
    }
}