package gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.sql.SQLException;

import javax.swing.BorderFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;

import Iterators.IteratorCliente;
import Iterators.IteratorDepartamento;
import Iterators.IteratorFuncionario;
import Iterators.IteratorModelo;
import Iterators.IteratorServico;
import Iterators.IteratorVeiculo;
import basicas.Cliente;
import basicas.Departamento;
import basicas.Funcionario;
import basicas.Modelo;
import basicas.Servico;
import basicas.Veiculo;

import execoes.DadoInexistenteException;
import fachada.Fachada;

@SuppressWarnings("serial")
public class PanelConsultar extends JPanel {

    private JButton botaoEditar;
    private JButton botaoConsultar;
    private JButton botaoRemover;
    private JButton botaoVoltar;
    
    private JTextField campoBusca;
    
    private JComboBox comboPesquisarPor;
    private JComboBox comboPesquisar;
    
    private JLabel rotuloConsultar;
    private JLabel rotuloPesquisarPor;
    private JLabel rotuloRemover;
    private JLabel rotuloEditar;
    private JLabel rotuloIrConsultar;
    
    private Tabela tabela;
    
    private String[] opcoesPesquisa;
    private String[] opcoesPesquisaCliente;
    private String[] opcoesPesquisaDepartamento;
    private String[] opcoesPesquisaFuncionario;
    private String[] opcoesPesquisaModelo;
    private String[] opcoesPesquisaServico;
    private String[] opcoesPesquisaVeiculo;
    
    private Fachada fachada;

    public PanelConsultar() {

        this.setBackground(Color.WHITE);
        TitledBorder title = BorderFactory.createTitledBorder("CONSULTAR");
        setBorder(title);

        try {
			this.fachada = Fachada.getInstace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        
        this.setSize(500, 300);
        setLayout(null);
        initComponents();
    }

    private void initComponents() {

        //criando os componentes
        campoBusca = new JTextField();
        comboPesquisarPor = new JComboBox();
        rotuloPesquisarPor = new JLabel();

        botaoConsultar = new JButton();
        botaoEditar = new JButton();
        botaoRemover = new JButton();
        botaoVoltar = new JButton();

        rotuloConsultar = new JLabel();
        comboPesquisar = new JComboBox();
        
        this.rotuloIrConsultar = new JLabel("Consultar Todos");
        this.rotuloRemover = new JLabel("Remover");
        this.rotuloEditar = new JLabel("Editar");

        opcoesPesquisa = new String[]{"Cliente", "Departamento", "Funcionrio",
                    "Modelo", "Servio", "Veculo"};

        opcoesPesquisaCliente = new String[]{"Nome", "CPF", "Nmero de Cadastro"};
        opcoesPesquisaDepartamento = new String[]{"Nmero", "Nome", "Local"};
        opcoesPesquisaFuncionario = new String[]{"Nmero De Contrato", "Nome",
                    "CPF", "RG"};
        opcoesPesquisaModelo = new String[]{"Nome", "Marca"};
        opcoesPesquisaServico = new String[]{"Cdigo do Servio", "Data", "Tipo"};
        opcoesPesquisaVeiculo = new String[]{"Nmero", "Placa", "Cor", "Ano",
                    "Modelo"};
        
        this.campoBusca.getDocument().addDocumentListener(new DocumentListener() {  
            public void changedUpdate(DocumentEvent e) {  
            	campoPreenchido(e);  
            }  
          
            public void removeUpdate(DocumentEvent e) {  
            	if(e.getDocument().getLength()==0){
            		campoVazio(e);
            	}else{
            		campoPreenchido(e);
            	}
            }  
          
            public void insertUpdate(DocumentEvent e) {  
            	campoPreenchido(e);   
            }  
        }); 
        campoBusca.setBounds(205, 60, 280, 20);

        comboPesquisarPor.setModel(new DefaultComboBoxModel(opcoesPesquisaCliente));
        comboPesquisarPor.setBounds(80, 60, 110, 20);

        rotuloPesquisarPor.setFont(new Font("Tahoma", 0, 12));
        rotuloPesquisarPor.setText("Por:");
        rotuloPesquisarPor.setBounds(50, 60, 30, 14);
        
        rotuloIrConsultar.setBounds(490, 90, 200, 20);
        botaoConsultar.setIcon(new ImageIcon("search.png"));
        botaoConsultar.setBounds(490, 45, 45, 48);
        botaoConsultar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evt) {
                try {
					clicouProcurar();
				} catch (DadoInexistenteException e) {
					JOptionPane.showMessageDialog(null, e.getMensagem(), "Erro", JOptionPane.ERROR_MESSAGE);
				}
            }
        });

        this.rotuloEditar.setBounds(115, 450, 40, 20);
        botaoEditar.setIcon(new ImageIcon("editar.gif"));
        botaoEditar.setEnabled(false);
        botaoEditar.setBounds(70, 450, 40, 45);
        botaoEditar.addMouseListener(new MouseAdapter() {

            @Override
            public void mouseClicked(MouseEvent evt) {
                clicouEditar();
            }
        });

        this.rotuloRemover.setBounds(265, 450, 50, 20);
        botaoRemover.setIcon(new ImageIcon("delete.gif"));
        botaoRemover.setEnabled(false);
        botaoRemover.setBounds(220, 450, 40, 45);
        botaoRemover.addMouseListener(new MouseAdapter() {

            @Override
            public void mouseClicked(MouseEvent evt) {
                clicouRemover();
            }
        });

        botaoVoltar.setIcon(new ImageIcon("back.png"));
        botaoVoltar.setBounds(750, 25, 32, 32);
        botaoVoltar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evt) {
                clicouVoltar();
            }
        });

        rotuloConsultar.setFont(new Font("Tahoma", 0, 12));
        rotuloConsultar.setText("Consultar:");
        rotuloConsultar.setBounds(20, 30, 60, 15);

        comboPesquisar.setModel(new DefaultComboBoxModel(opcoesPesquisa));
        comboPesquisar.setBounds(80, 30, 110, 20);
        comboPesquisar.addItemListener(new ItemListener() {
          public void itemStateChanged(ItemEvent evt) {
                mudouItemDoComboPesquisar(evt);
            }
        });
        
        this.tabela = new Tabela(opcoesPesquisaCliente);
        tabela.setBounds(20, 150, 520 , 275);

        add(campoBusca);
        add(comboPesquisarPor);
        add(rotuloPesquisarPor);
        add(botaoConsultar);
        add(botaoEditar);
        add(botaoRemover);
        add(botaoVoltar);
        add(rotuloConsultar);
        add(comboPesquisar);
        add(rotuloIrConsultar);
        add(rotuloEditar);
        add(rotuloRemover);        
        add(tabela);
    }

    protected void campoPreenchido(DocumentEvent e) {
    	try {
			String conteudo = e.getDocument().getText(0,e.getDocument().getLength());
			this.rotuloIrConsultar.setText("Consultar " + conteudo);
		} catch (BadLocationException e1) {
			this.rotuloIrConsultar.setText("Consultar");
		}
		
	}

	protected void campoVazio(DocumentEvent e) {
		this.rotuloIrConsultar.setText("Consultar Todos");
		
	}

	private void clicouEditar() {
    }

    private void clicouRemover() {
    }

    private void clicouProcurar() throws DadoInexistenteException {
    	
    	if(comboPesquisar.getSelectedItem().equals("Cliente")){
    		IteratorCliente resultadoDaBusca;
    		
    		if(comboPesquisarPor.getSelectedItem().equals("Nome")){
    			resultadoDaBusca = fachada.buscarClientesComParametro("Nome like ", campoBusca.getText());
    		
    		}else if(comboPesquisarPor.getSelectedItem().equals("CPF")){
    			resultadoDaBusca = fachada.buscarClientesComParametro("CPF = ", campoBusca.getText());
    	    
    		}else if(comboPesquisarPor.getSelectedItem().equals("Nmero de Cadastro")){
    			resultadoDaBusca = fachada.buscarClientesComParametro("Nmero de Cadastro", campoBusca.getText());
    	    
    		}else{
    			resultadoDaBusca = fachada.buscarTodosClientes();
    		}
    	
    	}else if(comboPesquisar.getSelectedItem().equals("Departamento")){
    		IteratorDepartamento resultadoDaBusca;
    		
    		if(comboPesquisarPor.getSelectedItem().equals("Nome")){
    	    	resultadoDaBusca = fachada.buscarDepartamentosComParametros("Nome", campoBusca.getText());
    		
    		}else if(comboPesquisarPor.getSelectedItem().equals("Local")){
    			resultadoDaBusca = fachada.buscarDepartamentosComParametros("Local", campoBusca.getText());
    		
    		}else if(comboPesquisarPor.getSelectedItem().equals("Nmero")){
    			resultadoDaBusca = fachada.buscarDepartamentosComParametros("Nmero", campoBusca.getText());
    		
    		}else{
    			resultadoDaBusca = fachada.buscarTodosDepartamentos();
    		}
    	
    	}else if(comboPesquisar.getSelectedItem().equals("Funcionrio")){
    		IteratorFuncionario resultadoDaBusca;
    		
    		if(comboPesquisarPor.getSelectedItem().equals("Nome")){
    	    	resultadoDaBusca = fachada.buscarFuncionariosComParametro("Nome", campoBusca.getText());
    		
    		}else if(comboPesquisarPor.getSelectedItem().equals("CPF")){
    			resultadoDaBusca = fachada.buscarFuncionariosComParametro("CPF", campoBusca.getText());
    		
    		}else if(comboPesquisarPor.getSelectedItem().equals("Nmero de Cadastro")){
    			resultadoDaBusca = fachada.buscarFuncionariosComParametro("Nmero de Cadastro", campoBusca.getText());
    		
    		}else if(comboPesquisarPor.getSelectedItem().equals("RG")){
    			resultadoDaBusca = fachada.buscarFuncionariosComParametro("RG", campoBusca.getText());
    		
    		}else{
    			resultadoDaBusca = fachada.buscarTodosFuncionarios();
    		}
    	
    	}else if(comboPesquisar.getSelectedItem().equals("Modelo")){
    		IteratorModelo resultadoDaBusca;
    		
    		if(comboPesquisarPor.getSelectedItem().equals("Nome")){
    			resultadoDaBusca = fachada.buscarModelosComParametro("Nome", campoBusca.getText());
    
    		}else if(comboPesquisarPor.getSelectedItem().equals("Marca")){
    			resultadoDaBusca = fachada.buscarModelosComParametro("Marca", campoBusca.getText());
    		
    		}else{
    			resultadoDaBusca = fachada.buscarTodosModelos();
    		}
    	
    	}else if(comboPesquisar.getSelectedItem().equals("Servio")){
    		IteratorServico resultadoDaBusca;
    		
    		if(comboPesquisarPor.getSelectedItem().equals("Cdigo do Servo")){
    	    	resultadoDaBusca = fachada.buscarServicosComParametro("Cdigo", campoBusca.getText());
    		}else if(comboPesquisarPor.getSelectedItem().equals("Data")){
    			resultadoDaBusca = fachada.buscarServicosComParametro("Data", campoBusca.getText());
    		}else if(comboPesquisarPor.getSelectedItem().equals("Tipo")){
    			resultadoDaBusca = fachada.buscarServicosComParametro("Tipo", campoBusca.getText());
    		}else{
    			resultadoDaBusca = fachada.buscarTodosServicos();
    		}
    	
    	}else if(comboPesquisar.getSelectedItem().equals("Veculo")){
    		IteratorVeiculo resultadoDaBusca;
    		
    		if(comboPesquisarPor.getSelectedItem().equals("Placa")){
    	    	resultadoDaBusca = fachada.buscarVeiculosComParametro("Placa", campoBusca.getText());
    		}else if(comboPesquisarPor.getSelectedItem().equals("Cor")){
    			resultadoDaBusca = fachada.buscarVeiculosComParametro("Cor", campoBusca.getText());
    		}else if(comboPesquisarPor.getSelectedItem().equals("Nmero")){
    			resultadoDaBusca = fachada.buscarVeiculosComParametro("Nmero", campoBusca.getText());
    		}else if(comboPesquisarPor.getSelectedItem().equals("Ano")){
    			resultadoDaBusca = fachada.buscarVeiculosComParametro("Ano", campoBusca.getText());
    		}else{
    			resultadoDaBusca = fachada.buscarTodosVeiculos();
    		}
    	}
    }

    public void clicouVoltar() {
        //O metodo deve ser reescrito
    }

    private void mudouItemDoComboPesquisar(ItemEvent evento) {

        if (evento.getItem().equals("Cliente")) {
        	tabela.setNomesColunas(opcoesPesquisaCliente);
            comboPesquisarPor.setModel(new DefaultComboBoxModel(opcoesPesquisaCliente));
        } else if (evento.getItem().equals("Departamento")) {
        	tabela.setNomesColunas(opcoesPesquisaDepartamento);
            comboPesquisarPor.setModel(new DefaultComboBoxModel(opcoesPesquisaDepartamento));
        } else if (evento.getItem().equals("Funcionrio")) {
        	tabela.setNomesColunas(opcoesPesquisaFuncionario);
            comboPesquisarPor.setModel(new DefaultComboBoxModel(opcoesPesquisaFuncionario));
        } else if (evento.getItem().equals("Modelo")) {
        	tabela.setNomesColunas(opcoesPesquisaModelo);
            comboPesquisarPor.setModel(new DefaultComboBoxModel(opcoesPesquisaModelo));
        } else if (evento.getItem().equals("Servio")) {
        	tabela.setNomesColunas(opcoesPesquisaServico);
            comboPesquisarPor.setModel(new DefaultComboBoxModel(opcoesPesquisaServico));
        } else if (evento.getItem().equals("Veculo")) {
        	tabela.setNomesColunas(opcoesPesquisaVeiculo);
            comboPesquisarPor.setModel(new DefaultComboBoxModel(opcoesPesquisaVeiculo));
        }
    }
}
