package gui;

import execoes.CamposObrigatoriosException;
import fachada.Fachada;

import java.awt.BorderLayout;
import java.awt.HeadlessException;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.sql.SQLException;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

import basicas.Cliente;
import basicas.Endereco;
import basicas.Telefone;

@SuppressWarnings("serial")
public class PanelEditarCliente extends JPanel {

	   private Fachada fachada;

		private JPanel painelCliente;
		private PanelEndereco painelEndereco;
		
		private JButton botaoSalvarModificacoes;
		private JButton botaoLimpar;
        private JButton botaoVoltar;
		
		private JLabel nome;
		private JLabel cpf;
		private JLabel email;

		private JTextField campoNome;
		private JTextField campoCpf;
		private JTextField campoEmail;
		
		private PanelLista panelTelefone;
		
		private Cliente clienteEscolhido;

		public PanelEditarCliente(Cliente cliente){
			
           try {
			fachada = Fachada.getInstace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

			this.setLayout(null);
			
			TitledBorder title;

			clienteEscolhido = cliente;
			
			this.painelCliente = new JPanel(null);
			title = BorderFactory.createTitledBorder("Cliente");		
			painelCliente.setBorder(title);	
			painelCliente.setBounds(30, 20, 600, 350);
			this.add(painelCliente, BorderLayout.CENTER);

			initComponentesCliente();
			
		}

		private void initComponentesCliente() {
			
			this.botaoSalvarModificacoes = new JButton("Salvar");
			this.botaoLimpar = new JButton("Limpar");
            this.botaoVoltar = new JButton();
		
		
			this.nome = new JLabel("Nome:");
	
			this.cpf = new JLabel("CPF:");
			this.email = new JLabel("E-mail:");
			
			this.campoNome = new JTextField(clienteEscolhido.getNome());
			this.campoCpf = new JTextField(clienteEscolhido.getCpf());
			this.campoEmail = new JTextField(clienteEscolhido.getEmail());
			
            this.panelTelefone = new PanelLista("Telefone:");
			
            Vector<Telefone> telefones = clienteEscolhido.getTelefones();
            for(int i = 0; i < telefones.size(); i++){
            	panelTelefone.inserirNaLista(telefones.get(i).getNumero());
            }
            
            painelEndereco = new PanelEndereco();
            Endereco endereco = clienteEscolhido.getEndereco();
			painelEndereco.setEndereco(endereco.getRua(), endereco.getComplemento(), endereco.getCep()
									,endereco.getNumero(), endereco.getBairro(), endereco.getCidade(),
									endereco.getEstado(), endereco.getPais());
            
			this.nome.setBounds(30, 25, 105, 20);
			this.campoNome.setBounds(30, 50, 260, 20);
			
			this.cpf.setBounds(30, 80, 40, 20);
			this.campoCpf.setBounds(30, 105, 260, 20);
			
			this.email.setBounds(30, 135, 40, 20);
			this.campoEmail.setBounds(30, 160, 260, 20);

            this.panelTelefone.setBounds(30, 200, 270, 100);

			this.painelCliente.add(this.nome);
			this.painelCliente.add(this.campoNome);
			this.painelCliente.add(this.cpf);
			this.painelCliente.add(this.campoCpf);
			this.painelCliente.add(this.email);
			this.painelCliente.add(this.campoEmail);
            this.painelCliente.add(this.panelTelefone);
			this.painelCliente.add(painelEndereco);

			this.botaoSalvarModificacoes.setBounds(640, 25, 100, 25);
            this.botaoSalvarModificacoes.addMouseListener(new MouseAdapter() {
               @Override
               public void mouseClicked(MouseEvent evt) {
                   try {
					clicouSalvar(clienteEscolhido.getNumeroDeCadastro());
				} catch (CamposObrigatoriosException e) {
					JOptionPane.showMessageDialog(null, e.getMensagem(), "Erro", JOptionPane.ERROR_MESSAGE);
				} catch (HeadlessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
               }
           });
			this.botaoLimpar.setBounds(640, 70, 100, 25);

           botaoVoltar.setIcon(new ImageIcon("back.png"));
           botaoVoltar.setBounds(750, 25, 32, 32);
           botaoVoltar.addMouseListener(new MouseAdapter() {
               @Override
               public void mouseClicked(MouseEvent evt) {
                   clicouVoltar();
               }
           });

			this.add(this.botaoSalvarModificacoes);
			this.add(this.botaoLimpar);
           this.add(botaoVoltar);
			
		}

       public void clicouVoltar() {
           //metodo deve ser reemplmentado
       }

       private void clicouSalvar(int numeroDoCliente) throws CamposObrigatoriosException, HeadlessException, SQLException {
       	
           String nome = campoNome.getText();
           String email = campoEmail.getText();
           String cpf = campoCpf.getText();

           Endereco endereco = painelEndereco.getEndereco();
           
           Vector<String> lista = panelTelefone.getLista();
           Vector<Telefone> telefones = new Vector<Telefone>();
           for (int i = 0; i < lista.size(); i++) {
           	telefones.add(new Telefone(lista.get(i)));
           }
           
           if(fachada.editarCliente(numeroDoCliente, nome, email, cpf, endereco, telefones)){
        		JOptionPane.showMessageDialog(null, "Operao realizada com sucesso", "Sucesso", JOptionPane.OK_OPTION);
		    }else{
				JOptionPane.showMessageDialog(null, "A operao no pode ser concluida, tente novamente", "Erro", JOptionPane.ERROR_MESSAGE);
			}
       }
  }
