package gui;

import java.awt.BorderLayout;
import java.awt.HeadlessException;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.sql.SQLException;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

import basicas.Funcionario;
import basicas.Servico;
import execoes.CamposObrigatoriosException;
import execoes.DadoInexistenteException;
import execoes.FormatoDataInvalidoException;
import fachada.Fachada;

@SuppressWarnings("serial")
public class PanelEditarServico extends JPanel {

	    private JPanel painel1;
	    private JButton botaoSalvarModificacoes;
	    private JButton botaoLimpar;
	    private JButton botaoVoltar;
	    private JLabel formaDePagamento;
	    private JLabel valor;
	    private JLabel data;
	    
	    private JLabel barraData1;
	    private JLabel barraData2;
	    
	    private JLabel desconto;
	    private JLabel descricao;
	    private JLabel numeroVeiculo;
	    private JLabel numeroDeCadastroCliente;
	    private JTextField campoFormaDePagamento;
	    private JTextField campoValor;
	    
	    private JTextField campoDia;
	    private JTextField campoMes;
	    private JTextField campoAno;
	    
	    private JTextField campoDesconto;
	    private JTextField campoDescricao;
	    private JTextField campoNumeroVeiculo;
	    private JTextField campoNumeroDeCadastroCliente;
	    
	    private Servico servicoEscolhido;
	    
	    private Fachada fachada;
	    
	    private PanelLista listaFuncionariosResponsaveis;
	    
	    public PanelEditarServico(Servico servico) {

	        this.setLayout(null);

	        try {
				fachada = Fachada.getInstace();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	        
	        TitledBorder title;

	        servicoEscolhido = servico;
	        
	        this.painel1 = new JPanel(null);
	        title = BorderFactory.createTitledBorder("Servio");
	        painel1.setBorder(title);
	        painel1.setBounds(30, 20, 600, 450);
	        this.add(painel1, BorderLayout.CENTER);

	        initComponentesFuncionario();

	    }

	    private void initComponentesFuncionario() {

	        this.botaoSalvarModificacoes = new JButton("Cadastrar");
	        this.botaoLimpar = new JButton("Limpar");
	        botaoVoltar = new JButton();

	        this.formaDePagamento = new JLabel("Forma de pagamento:");
	        this.valor = new JLabel("Valor:");
	        this.data = new JLabel("Data:");
	        this.barraData1 = new JLabel("/");
	        this.barraData2 = new JLabel("/");
	        this.desconto = new JLabel("Desconto:");
	        this.descricao = new JLabel("Descrio:");
	        this.numeroVeiculo = new JLabel("Nmero de cadastro do Veculo:");
	        this.numeroDeCadastroCliente = new JLabel("Nmero de cadastro do Cliente:");

	        this.campoFormaDePagamento = new JTextField(servicoEscolhido.getPagamento());

	        this.campoValor = new JTextField(servicoEscolhido.getValor() + "");
	        
	        String dia = servicoEscolhido.getDataHora().charAt(0) + "" + servicoEscolhido.getDataHora().charAt(1);
	        this.campoDia = new JTextField(dia);
	        String mes = servicoEscolhido.getDataHora().charAt(3) + "" + servicoEscolhido.getDataHora().charAt(4);
	        this.campoMes = new JTextField(mes);
	        String ano = servicoEscolhido.getDataHora().charAt(6) + "" + servicoEscolhido.getDataHora().charAt(7) + "" + 
	        			servicoEscolhido.getDataHora().charAt(8) + "" + servicoEscolhido.getDataHora().charAt(9);
	        this.campoAno = new JTextField(ano);
	        
	        this.campoDesconto = new JTextField(servicoEscolhido.getDesconto() + "");
	        this.campoDescricao = new JTextField(servicoEscolhido.getDescricao());
	        this.campoNumeroVeiculo = new JTextField(servicoEscolhido.getVeiculo().getNumeroDeCadastro() + "");
	        this.campoNumeroDeCadastroCliente = new JTextField(servicoEscolhido.getClienteQueSolicitou().getNumeroDeCadastro() + "");
	        
	        this.listaFuncionariosResponsaveis = new PanelLista("Funcionrios:");

	        this.formaDePagamento.setBounds(30, 25, 150, 20);
	        this.campoFormaDePagamento.setBounds(30, 50, 260, 20);

	        this.valor.setBounds(30, 80, 40, 20);
	        this.campoValor.setBounds(30, 105, 260, 20);

	        this.desconto.setBounds(30, 135, 60, 20);
	        this.campoDesconto.setBounds(30, 160, 260, 20);

	        this.data.setBounds(30, 190, 60, 20);
	             
	        this.campoDia.setBounds(30, 215, 25, 20);
	        this.barraData1.setBounds(65, 215, 20, 20);
	        this.campoMes.setBounds(75, 215, 25, 20);
	        this.barraData2.setBounds(110, 215, 20, 20);
	        this.campoAno.setBounds(120, 215, 35, 20);
	        
	        this.descricao.setBounds(30, 245, 100, 20);
	        this.campoDescricao.setBounds(30, 270, 260, 20);

	        this.numeroVeiculo.setBounds(30, 300, 200, 20);
	        this.campoNumeroVeiculo.setBounds(30, 325, 260, 20);

	        this.numeroDeCadastroCliente.setBounds(30, 355, 200, 20);
	        this.campoNumeroDeCadastroCliente.setBounds(30, 380, 260, 20);
	        
	        this.listaFuncionariosResponsaveis.setBounds(310, 350, 270, 70);
	        Vector<Funcionario> funcionariosResponsaveis = this.servicoEscolhido.getFuncionarios();
	        for(int i = 0; i < funcionariosResponsaveis.size(); i++){
	        	this.listaFuncionariosResponsaveis.inserirNaLista(funcionariosResponsaveis.get(i).getNome());
	        }
	        
	        this.painel1.add(this.formaDePagamento);
	        this.painel1.add(this.campoFormaDePagamento);
	        this.painel1.add(this.valor);
	        this.painel1.add(this.campoValor);
	        this.painel1.add(this.data);
	        this.painel1.add(this.campoDia);
	        this.painel1.add(this.campoMes);
	        this.painel1.add(this.campoAno);
	        this.painel1.add(this.barraData1);
	        this.painel1.add(this.barraData2);
	        this.painel1.add(this.desconto);
	        this.painel1.add(this.campoDesconto);
	        this.painel1.add(this.descricao);
	        this.painel1.add(this.campoDescricao);
	        this.painel1.add(this.numeroVeiculo);
	        this.painel1.add(this.campoNumeroVeiculo);
	        this.painel1.add(this.numeroDeCadastroCliente);
	        this.painel1.add(this.campoNumeroDeCadastroCliente);
	        this.painel1.add(this.listaFuncionariosResponsaveis);
	        
	        this.botaoSalvarModificacoes.setBounds(640, 25, 100, 25);
	        botaoSalvarModificacoes.addMouseListener(new MouseAdapter() {
	            @Override
	            public void mouseClicked(MouseEvent evt) {
	                try {
						clicouSalvar(servicoEscolhido.getNumeroDeCadastro());
	            	} catch (CamposObrigatoriosException e) {
						JOptionPane.showMessageDialog(null, e.getMensagem(), "Erro", JOptionPane.ERROR_MESSAGE);
					} catch (DadoInexistenteException e){
						JOptionPane.showMessageDialog(null, e.getMensagem(), "Erro", JOptionPane.ERROR_MESSAGE);
					} catch (FormatoDataInvalidoException e){
						JOptionPane.showMessageDialog(null, e.getMensagem(), "Erro", JOptionPane.ERROR_MESSAGE);
					} catch (Exception e){
						JOptionPane.showMessageDialog(null, "Verifique se todas as entradas esto no formato correto", "Erro", JOptionPane.ERROR_MESSAGE);
					}
	            }
	        });
	        
	        botaoVoltar.setIcon(new ImageIcon("back.png"));
	        botaoVoltar.setBounds(750, 25, 32, 32);
	        botaoVoltar.addMouseListener(new MouseAdapter() {
	            @Override
	            public void mouseClicked(MouseEvent evt) {
	                clicouVoltar();
	            }
	        });
	        
	        this.botaoLimpar.setBounds(640, 70, 100, 25);
	        
	        this.add(this.botaoSalvarModificacoes);
	        this.add(this.botaoLimpar);
	        this.add(this.botaoVoltar);

	    }

	    public void clicouVoltar() {
	        //metodo deve ser reemplmentado
	    }
	    
	    public void clicouSalvar(int numeroDeCadastro) throws CamposObrigatoriosException, HeadlessException, DadoInexistenteException, FormatoDataInvalidoException, SQLException{
	    	
	    	String formaDePagamento = campoFormaDePagamento.getText();
	        double valor = Integer.parseInt(campoValor.getText());
	       
	        String dia = campoDia.getText();
	        String mes = campoMes.getText();
	        String ano = campoAno.getText();
	        
	        if(dia.length() != 2 || mes.length() != 2 || ano.length() != 4)
	        	throw new FormatoDataInvalidoException();
	        
	        String data = dia + "/" + mes + "/" + ano;
	        
	        double desconto = Double.parseDouble(campoDesconto.getText());
	        String descricao = campoDescricao.getText();
	        int numeroCadastroDoVeiculo = Integer.parseInt(campoNumeroVeiculo.getText());
	        int numeroCadastroDoCliente = Integer.parseInt(campoNumeroDeCadastroCliente.getText());
	     
	        Vector<String> nomes = listaFuncionariosResponsaveis.getLista();
	        Vector<Funcionario> funcionariosResponsaveis = new Vector<Funcionario>();
	        for(int i = 0; i < nomes.size(); i++){
	        	Funcionario funcionario = new Funcionario();
	        	funcionario.setNome(nomes.get(i));
	        	funcionariosResponsaveis.add(funcionario);
	        }
	        
	        if(fachada.editarServico(numeroDeCadastro, formaDePagamento, valor, data, desconto, descricao, numeroCadastroDoVeiculo, numeroCadastroDoCliente, funcionariosResponsaveis)){
	        	JOptionPane.showMessageDialog(null, "Operao realizada com sucesso", "Sucesso", JOptionPane.OK_OPTION);
		    }else{
				JOptionPane.showMessageDialog(null, "A operao no pode ser concluida, tente novamente", "Erro", JOptionPane.ERROR_MESSAGE);
			}
	    }
	  
}
