package gui;

import java.awt.BorderLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.sql.SQLException;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

import basicas.Veiculo;
import execoes.CamposObrigatoriosException;
import fachada.Fachada;

@SuppressWarnings("serial")
public class PanelEditarVeiculo extends JPanel {

	private JPanel painel1;
	
	private JButton botaoSalvarModificacoes;
	private JButton botaoLimpar;
    private JButton botaoVoltar;
	
	private JLabel ano;
	private JLabel cor;
	private JLabel placa;
	private JLabel chassi;
	private JLabel codigoDoModelo;
	
	private JTextField campoAno;
	private JTextField campoCor;
	private JTextField campoPlaca;
	private JTextField campoChassi;
	private JTextField campoCodigoDoModelo;
	
	private Fachada fachada;
	
	private Veiculo veiculoEscolhido;
	
	public PanelEditarVeiculo(Veiculo veiculo){
		
		this.setLayout(null);
		
		TitledBorder title;
		
		try {
			fachada = Fachada.getInstace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		veiculoEscolhido = veiculo;
		
		this.painel1 = new JPanel(null);
		title = BorderFactory.createTitledBorder("Veculo");
		painel1.setBorder(title);	
		painel1.setBounds(30, 20, 600, 330);
		this.add(painel1, BorderLayout.CENTER);

		initComponentesFuncionario();
		
	}

	private void initComponentesFuncionario() {
		
		this.botaoSalvarModificacoes = new JButton("Cadastrar");
		this.botaoLimpar = new JButton("Limpar");
        this.botaoVoltar = new JButton();
	
		this.ano = new JLabel("Ano:");
		this.cor = new JLabel("Cor:");
		this.placa = new JLabel("Placa:");
		this.chassi = new JLabel("Chassi:");
		this.codigoDoModelo = new JLabel("Cdigo do Modelo:");
	
		this.campoAno = new JTextField(veiculoEscolhido.getAno());
		this.campoCor = new JTextField(veiculoEscolhido.getCor());
		this.campoPlaca = new JTextField(veiculoEscolhido.getPlaca());
		this.campoChassi = new JTextField(veiculoEscolhido.getChassi());
		this.campoCodigoDoModelo = new JTextField(veiculoEscolhido.getModelo().getNumeroModelo() + "");
			
		this.ano.setBounds(30, 25, 40, 20);
		this.campoAno.setBounds(30, 50, 260, 20);
		
		this.cor.setBounds(30, 80, 40, 20);
		this.campoCor.setBounds(30, 105, 260, 20);
		
		this.placa.setBounds(30, 135, 60, 20);
		this.campoPlaca.setBounds(30, 160, 260, 20);

		this.chassi.setBounds(30, 190, 60, 20);
		this.campoChassi.setBounds(30, 215, 260, 20);
		
		this.codigoDoModelo.setBounds(30, 245, 100, 20);
		this.campoCodigoDoModelo.setBounds(30, 270, 260, 20);
		
		this.painel1.add(this.ano);
		this.painel1.add(this.campoAno);
		this.painel1.add(this.cor);
		this.painel1.add(this.campoCor);
		this.painel1.add(this.placa);
		this.painel1.add(this.campoPlaca);
		this.painel1.add(this.chassi);
		this.painel1.add(this.campoChassi);
		this.painel1.add(this.codigoDoModelo);
		this.painel1.add(this.campoCodigoDoModelo);

		
		this.botaoSalvarModificacoes.setBounds(640, 25, 100, 25);
		 botaoSalvarModificacoes.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent evt) {
                	try {
						clicouSalvar(veiculoEscolhido.getNumeroDeCadastro());
					} catch (CamposObrigatoriosException e) {
						JOptionPane.showMessageDialog(null, e.getMensagem(), "Erro", JOptionPane.ERROR_MESSAGE);
					} catch (Exception e){
						JOptionPane.showMessageDialog(null, "Verifique se todas as entradas esto no formato correto", "Erro", JOptionPane.ERROR_MESSAGE);
					}
                }
            });
	
		 this.botaoLimpar.setBounds(640, 70, 100, 25);
        
		botaoVoltar.setIcon(new ImageIcon("back.png"));
        botaoVoltar.setBounds(750, 25, 32, 32);
        botaoVoltar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evt) {
                clicouVoltar();
            }
        });
		
		this.add(this.botaoSalvarModificacoes);
		this.add(this.botaoLimpar);
        this.add(botaoVoltar);
		
	}


    public void clicouVoltar() {
        //metodo deve ser reemplmentado

    }
    
    public void clicouSalvar(int numeroDeCadastro) throws CamposObrigatoriosException{
    	
    	String ano = campoAno.getText();
		String cor = campoCor.getText();
		String placa = campoPlaca.getText();
		String chassi = campoChassi.getText();
		int numeroModelo = Integer.parseInt(campoCodigoDoModelo.getText());
		
		if(fachada.editarVeiculo(numeroDeCadastro, ano, cor, placa, chassi, numeroModelo)){
			JOptionPane.showMessageDialog(null, "Operao realizada com sucesso", "Sucesso", JOptionPane.OK_OPTION);
	    }else{
			JOptionPane.showMessageDialog(null, "A operao no pode ser concluida, tente novamente", "Erro", JOptionPane.ERROR_MESSAGE);
		}
    }
}
