package gui;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import execoes.CamposObrigatoriosException;

import basicas.Endereco;


@SuppressWarnings("serial")
public class PanelEndereco extends JPanel {
	
	private JLabel rua; 
	private JLabel numero; 
	private JLabel complemento; 
	private JLabel bairro; 
	private JLabel cidade; 
	private JLabel estado; 
	private JLabel pais; 
	private JLabel CEP;
	
	private JTextField campoRua; 
	private JTextField campoNumero; 
	private JTextField campoComplemento; 
	private JTextField campoBairro; 
	private JTextField campoCidade; 
	private JTextField campoEstado; 
	private JTextField campoPais; 
	private JTextField campoCEP;
	
	public PanelEndereco() {		
	
		this.setLayout(null);
		this.setBorder(BorderFactory.createTitledBorder("Endereo"));
		this.setLocation(320, 20);
		this.setSize(260, 310);
				
		this.initComponents();
		
		this.addComponents();	
	}
	
	private void initComponents() {
		
		this.rua = new JLabel("Rua:"); 
	    this.numero = new JLabel("Nmero:");
		this.complemento = new JLabel("Complemento:"); 
		this.bairro = new JLabel("Bairro:"); 
		this.cidade = new JLabel("Cidade:"); 
		this.estado = new JLabel("UF:"); 
		this.pais = new JLabel("Pas:");
		this.CEP = new JLabel("CEP");

		this.campoRua = new JTextField(); 
		this.campoNumero = new JTextField(); 
		this.campoComplemento = new JTextField(); 
		this.campoBairro = new JTextField(); 
		this.campoCidade = new JTextField(); 
		this.campoEstado = new JTextField(); 
		this.campoPais = new JTextField(); 
		this.campoCEP = new JTextField();
		
		this.rua.setBounds(30, 25, 105, 20);
		this.campoRua.setBounds(30, 50, 200, 20);
		
		this.numero.setBounds(30, 80, 80, 20);
		this.campoNumero.setBounds(30, 105, 60, 20);
		
		this.complemento.setBounds(110, 80, 100, 20);
		this.campoComplemento.setBounds(110, 105, 120, 20);
		
		this.bairro.setBounds(30, 135, 50, 20);
		this.campoBairro.setBounds(30, 160, 90, 20);
		
		this.cidade.setBounds(140, 135, 60, 20);
		this.campoCidade.setBounds(140, 160, 90, 20);
		
		this.estado.setBounds(30, 190, 20, 20);
		this.campoEstado.setBounds(30, 215, 50, 20);
		
		this.pais.setBounds(100, 190, 40, 20);
		this.campoPais.setBounds(100, 215, 130, 20);
		
		this.CEP.setBounds(30, 245, 20, 20);
		this.campoCEP.setBounds(30, 270, 200, 20);
		
	}
	
	private void addComponents() {
		
		this.add(this.rua);
		this.add(this.numero);
		this.add(this.bairro);
		this.add(this.cidade);
		this.add(this.pais);
		this.add(this.estado);
		this.add(this.CEP);
		this.add(this.complemento);
		this.add(this.campoRua);
		this.add(this.campoNumero);
		this.add(this.campoBairro);
		this.add(this.campoCidade);
		this.add(this.campoPais);
		this.add(this.campoEstado);
		this.add(this.campoCEP);
		this.add(this.campoComplemento);
		
	}
	
	public Endereco getEndereco () throws CamposObrigatoriosException {
		Endereco retorno;
		
		String rua = campoRua.getText();
        String complemento = campoComplemento.getText();
        String cep = campoCEP.getText();
        String numero = campoNumero.getText();
        String bairro = campoBairro.getText();
        String cidade = campoCidade.getText();
        String estado = campoEstado.getText();
        String pais = campoPais.getText();
		

		if(rua.trim().equals("") || cep.trim().equals("")
		   || bairro.trim().equals("") || numero.trim().equals("")
		   || cidade.trim().equals("") || estado.trim().equals("")
		   || pais.trim().equals("")
			){
			throw new CamposObrigatoriosException();
		}
        
        retorno = new Endereco(complemento, cep, numero,
                rua, bairro, cidade, estado, pais);
		
        return retorno;
	}
	
	public void setEndereco(String rua, String complemento, String cep, String numero, String bairro,
							String cidade, String estado, String pais){
		campoRua.setText(rua);
		campoComplemento.setText(complemento);
		campoCEP.setText(cep);
		campoNumero.setText(numero);
		campoBairro.setText(bairro);
		campoCidade.setText(cidade);
		campoEstado.setText(estado);
		campoPais.setText(pais);
	}
	
	public void limparCampos() {
		campoRua.setText("");
		campoComplemento.setText("");
		campoCEP.setText("");
		campoNumero.setText("");
		campoBairro.setText("");
		campoCidade.setText("");
		campoEstado.setText("");
		campoPais.setText("");
	}
}
