package gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;

import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.border.TitledBorder;

@SuppressWarnings("serial")
public class PanelGerarRelatorio extends JPanel {

    private JList lista;
    private JScrollPane scroll;
    private DefaultListModel model;
    private JPanel painel1;
    private JPanel painel2;
    private JLabel dataInicial;
    private JLabel dataFinal;
    private JLabel barra1;
    private JLabel barra2;
    private JLabel barra3;
    private JLabel barra4;
    private JTextField campoDiaInicial;
    private JTextField campoMesInicial;
    private JTextField campoAnoInicial;
    private JTextField campoDiaFinal;
    private JTextField campoMesFinal;
    private JTextField campoAnoFinal;
    private JButton botaoGerar;
    private JButton botaoVoltar;
    private ButtonGroup group;
    private JRadioButton opcaoPeriodo;
    private JRadioButton opcaoDepartamento;
    private JRadioButton opcaoFuncionario;
    private JRadioButton opcaoCliente;
    private JRadioButton opcaoServico;
    private JRadioButton opcaoGeral;
    

    public PanelGerarRelatorio() {

        this.setLayout(null);

        TitledBorder title;

        this.painel1 = new JPanel(null);
        title = BorderFactory.createTitledBorder("Relatrio");
        painel1.setBorder(title);
        painel1.setBounds(30, 20, 600, 140);
        this.add(painel1, BorderLayout.CENTER);


        this.painel2 = new JPanel(null);

        initComponentesFuncionario();

    }

    private void initComponentesFuncionario() {

        this.scroll = new JScrollPane();
        this.model = new DefaultListModel();
        this.lista = new JList(this.model);

        this.campoDiaInicial = new JTextField();
        this.campoMesInicial = new JTextField();
        this.campoAnoInicial = new JTextField();
        this.campoDiaFinal = new JTextField();
        this.campoMesFinal = new JTextField();
        this.campoAnoFinal = new JTextField();

        this.dataInicial = new JLabel("Data inicial:");
        this.dataFinal = new JLabel("Data final:");

        this.barra1 = new JLabel("/");
        this.barra2 = new JLabel("/");
        this.barra3 = new JLabel("/");
        this.barra4 = new JLabel("/");

        this.botaoGerar = new JButton("Gerar");

        this.group = new ButtonGroup();

        this.opcaoPeriodo = new JRadioButton("Por Perodo");
        this.opcaoDepartamento = new JRadioButton("Por Departamento");
        this.opcaoFuncionario = new JRadioButton("Por Funcionrio");
        this.opcaoCliente = new JRadioButton("Por Cliente");
        this.opcaoServico = new JRadioButton("Por Servio");
        this.opcaoGeral = new JRadioButton("Geral");

        //opcaoCliente.setSelected(true);

        this.group.add(this.opcaoCliente);
        this.group.add(this.opcaoDepartamento);
        this.group.add(this.opcaoFuncionario);
        this.group.add(this.opcaoPeriodo);
        this.group.add(this.opcaoServico);
        this.group.add(this.opcaoGeral);

        this.opcaoCliente.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent evt) {
                opcaoPerformed();
            }
        });

        this.opcaoDepartamento.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                opcaoPerformed();
            }
        });

        this.opcaoServico.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                opcaoPerformed();
            }
        });

        this.opcaoPeriodo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                opcaoPeriodoPerformed();
            }
        });

        this.opcaoFuncionario.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                opcaoPerformed();
            }
        });

        this.opcaoGeral.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                opcaoPerformed();
            }
        });

        this.scroll.setBounds(30, 180, 600, 325);
        this.scroll.setViewportView(this.lista);

        this.opcaoCliente.setBounds(30, 25, 80, 20);
        this.opcaoDepartamento.setBounds(30, 55, 120, 20);
        this.opcaoFuncionario.setBounds(30, 85, 100, 20);

        this.opcaoPeriodo.setBounds(170, 25, 100, 20);
        this.opcaoServico.setBounds(170, 55, 100, 20);
        this.opcaoGeral.setBounds(170, 85, 100, 20);

        botaoGerar.setIcon(new ImageIcon("gerar.png"));
        botaoGerar.setBounds(660, 25, 80, 30);
        botaoGerar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked (MouseEvent evt) {
                clicouGerar();
            }
        });

        botaoVoltar = new JButton();
        botaoVoltar.setBounds(750, 25, 32, 32);
        botaoVoltar.setIcon(new ImageIcon("back.png"));
        botaoVoltar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked (MouseEvent evt) {
                clicouVoltar();
            }
        });

        this.painel1.add(this.opcaoCliente);
        this.painel1.add(this.opcaoDepartamento);
        this.painel1.add(this.opcaoFuncionario);
        this.painel1.add(this.opcaoPeriodo);
        this.painel1.add(this.opcaoServico);
        this.painel1.add(this.opcaoGeral);

        this.add(botaoVoltar);
        this.add(botaoGerar);
        this.add(this.scroll);

    }

    private void opcaoPeriodoPerformed() {

        this.dataInicial.setBounds(30, 25, 60, 20);

        this.campoDiaInicial.setBounds(100, 25, 20, 20);
        this.barra1.setBounds(130, 25, 5, 20);
        this.campoMesInicial.setBounds(140, 25, 20, 20);
        this.barra2.setBounds(170, 25, 5, 20);
        this.campoAnoInicial.setBounds(180, 25, 35, 20);

        this.dataFinal.setBounds(30, 60, 60, 20);

        this.campoDiaFinal.setBounds(100, 60, 20, 20);
        this.barra3.setBounds(130, 60, 5, 20);
        this.campoMesFinal.setBounds(140, 60, 20, 20);
        this.barra4.setBounds(170, 60, 5, 20);
        this.campoAnoFinal.setBounds(180, 60, 35, 20);


        this.painel2.removeAll();

        this.painel2.add(this.dataInicial);
        this.painel2.add(this.dataFinal);
        this.painel2.add(this.campoDiaInicial);
        this.painel2.add(this.campoMesInicial);
        this.painel2.add(this.campoAnoInicial);
        this.painel2.add(this.campoDiaFinal);
        this.painel2.add(this.campoMesFinal);
        this.painel2.add(this.campoAnoFinal);
        this.painel2.add(this.barra1);
        this.painel2.add(this.barra2);
        this.painel2.add(this.barra3);
        this.painel2.add(this.barra4);

        initPanel2("Periodo");
        SwingUtilities.updateComponentTreeUI(this);

    }

    private void opcaoPerformed() {
        this.painel1.remove(this.painel2);
        SwingUtilities.updateComponentTreeUI(this);

    }

    private void initPanel2(String s) {

        TitledBorder title = BorderFactory.createTitledBorder(s);
        painel2.setBorder(title);
        painel2.setBounds(320, 20, 260, 100);
        painel1.add(painel2);

    }

    public void clicouVoltar() {
        //O mtodo deve ser reescrito
    }

    private void clicouGerar() {
        
    }
}
