package gui;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Vector;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;


@SuppressWarnings("serial")
public class PanelLista extends JPanel {
	
	private String titulo;
	
    private JButton botaoAdicionar;
    private JButton botaoRemover;
    private JTextField campoTelefone;
    private DefaultListModel modeloLista;
    private JList listaDeTelefones;
    private JLabel rotuloTelefone;
    private JScrollPane scrollDaLista;

    public PanelLista (String titulo) {
         setLayout(null);
         this.titulo = titulo;
         initComponents();
    }

    private void initComponents() {

        rotuloTelefone = new JLabel();
        campoTelefone = new JTextField();
        botaoAdicionar = new JButton();
        botaoRemover = new JButton();
        scrollDaLista = new JScrollPane();
        modeloLista = new DefaultListModel();
        listaDeTelefones = new JList(modeloLista);

        rotuloTelefone.setText(titulo);
        add(rotuloTelefone);
        rotuloTelefone.setBounds(0, 10, 90, 14);

        add(campoTelefone);
        campoTelefone.setBounds(0, 30, 70, 20);

        botaoAdicionar.setText("Adicionar >>");
        botaoAdicionar.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evt) {
                clicouAdicionar();
            }
        });
        add(botaoAdicionar);
        botaoAdicionar.setBounds(80, 10, 95, 23);

        botaoRemover.setText("<< Remover");
        botaoRemover.setEnabled(false);
        botaoRemover.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evt) {
                clicouRemover();
            }
        });
        add(botaoRemover);
        botaoRemover.setBounds(80, 40, 95, 23);

        scrollDaLista.setViewportView(listaDeTelefones);
        add(scrollDaLista);
        scrollDaLista.setBounds(190, 10, 70, 60);
    }

    private void clicouAdicionar() {
        String novoTelefone = campoTelefone.getText();
        campoTelefone.setText("");
        if (!novoTelefone.equals("")) {
            modeloLista.addElement(novoTelefone);
            botaoRemover.setEnabled(true);
        }
        listaDeTelefones.setSelectedIndex(0);
    }

    private void clicouRemover() {
        int telefoneRemovido = listaDeTelefones.getSelectedIndex();
        modeloLista.removeElementAt(telefoneRemovido);

        if (modeloLista.isEmpty()) {
            botaoRemover.setEnabled(false);
        } else {
            listaDeTelefones.setSelectedIndex(0);
        }
    }

    public Vector<String> getLista() {
        Vector<String> telefones = new Vector<String>();
        int qtdDeTelefones = modeloLista.getSize();

        for (int i = 0; i < qtdDeTelefones; i++) {
        	telefones.add((String)modeloLista.getElementAt(i));
        }
        
        return telefones;
    }
    
    public void inserirNaLista(String elemento){
    	modeloLista.addElement(elemento);
    }
    
    public void limparLista() {
    	modeloLista.clear();
    	botaoRemover.setEnabled(false);
    }
}
