package interfaceNegocio;

import java.util.Vector;

import execoes.CamposObrigatoriosException;
import execoes.DadoInexistenteException;

import Iterators.IteratorFuncionario;
import basicas.Cliente;
import basicas.Endereco;
import basicas.Funcionario;
import basicas.Telefone;

public interface INegocioFuncionario {

	public boolean cadastrar(String nome, String senha,
			String dataDeNascimento, String cpf, String rg, String cargo,
			double salario, int numeroDepartamento, Endereco endereco,
            Vector<Telefone> telefones) throws CamposObrigatoriosException, DadoInexistenteException;
	public boolean remover(int numeroDeCadastro);
	public Funcionario buscar(int numeroDeCadastro) throws DadoInexistenteException;
	public IteratorFuncionario buscarTodos();
	public IteratorFuncionario buscaComParametros(String campoEscolhido, String valorEscolhido);
	public boolean editar(int numeroDeCadastro, String nome, String senha,
			String dataDeNascimento, String cpf, String rg, String cargo,
			double salario, int numeroDepartamento, Endereco endereco,
            Vector<Telefone> telefones) throws CamposObrigatoriosException, DadoInexistenteException;
	
	public boolean efetuarLogin(int cadastro, String senha) throws DadoInexistenteException;
}
