package negocios;

import java.sql.SQLException;
import java.util.Vector;

import execoes.CamposObrigatoriosException;
import execoes.DadoInexistenteException;

import Iterators.IteratorCliente;
import basicas.Cliente;
import basicas.Endereco;
import basicas.Telefone;
import interfaceNegocio.INegocioCliente;
import repositorio.RepCliente;

public class NegocioCliente implements INegocioCliente{

    private RepCliente repositorio;

    public NegocioCliente () throws ClassNotFoundException, SQLException {
    	repositorio = new RepCliente();
    }
    
    public boolean cadastrar(String nome, String email, String cpf,
    		Endereco endereco, Vector<Telefone> telefones) throws CamposObrigatoriosException, SQLException {
    
    	if(nome.trim().equals("") || cpf.trim().equals("") || endereco == null || telefones.size() < 1 ){
    		throw new CamposObrigatoriosException();
    	}
    	
    	Cliente cliente = new Cliente(nome, email, cpf,
        		endereco, telefones);
    	
    	return repositorio.cadastrar(cliente);
    }
    
    public boolean editar(int numeroDeCadastro, String nome, String email,
    		String cpf, Endereco endereco, Vector<Telefone> telefones) throws CamposObrigatoriosException, SQLException{
    	
    	if(numeroDeCadastro == 0 || nome.trim().equals("") || cpf.trim().equals("") || endereco == null || telefones.size() < 1 ){
    		throw new CamposObrigatoriosException();
    	}
    	
    	Cliente cliente = new Cliente(nome, email, cpf,
        		endereco, telefones);
    	cliente.setNumeroDeCadastro(numeroDeCadastro);
    	
    	return repositorio.cadastrar(cliente);
    }
    
    public boolean remover(int numeroDeCadastro) throws SQLException {
    	Cliente cliente = new Cliente();
    	cliente.setNumeroDeCadastro(numeroDeCadastro);
    	return repositorio.remover(cliente);
    }

    public Cliente buscar(int numeroDeCadastro) throws DadoInexistenteException, SQLException {
    	Cliente cliente = new Cliente();
    	cliente.setNumeroDeCadastro(numeroDeCadastro);
    	
    	Cliente retorno = repositorio.buscar(cliente);
    	
    	if(retorno == null)
    		throw new DadoInexistenteException("Cliente");
    		
    	return repositorio.buscar(cliente);
    }

	public IteratorCliente buscaComParametros(String campoEscolhido,
			String valorEscolhido) {
		return null;
	}

	public IteratorCliente buscarTodos() {
		return null;
	}


}
