package negocios;

import execoes.CamposObrigatoriosException;
import execoes.DadoInexistenteException;
import repositorio.RepModelo;
import Iterators.IteratorModelo;
import basicas.Modelo;
import interfaceNegocio.INegocioModelo;

public class NegocioModelo implements INegocioModelo {

	private RepModelo repositorio;
	
	public NegocioModelo(){
		repositorio = new RepModelo();
	}
	
	public Modelo buscar(int numeroDeCadastro) throws DadoInexistenteException {
		Modelo modelo = new Modelo();
		modelo.setNumeroModelo(numeroDeCadastro);
		
		Modelo retorno = repositorio.buscar(modelo);
		
		if(retorno == null)
			throw new DadoInexistenteException("Modelo");
		
		return retorno;
	}

	public boolean cadastrar(String marca, String modelo) throws CamposObrigatoriosException {
		Modelo modeloEscolhido = new Modelo(marca, modelo);
		
		if(marca.trim().equals("") || modelo.trim().equals("")){
			throw new CamposObrigatoriosException();
		}
		
		return repositorio.cadastrar(modeloEscolhido);
	}

	public boolean editar(int numeroDeCadastro, String marca, String modelo) throws CamposObrigatoriosException {
		Modelo modeloEscolhido = new Modelo(marca, modelo);
		modeloEscolhido.setNumeroModelo(numeroDeCadastro);
		
		if(numeroDeCadastro == 0 || marca.trim().equals("") || modelo.trim().equals("")){
			throw new CamposObrigatoriosException();
		}
		
		return repositorio.editar(modeloEscolhido);
	}

	public boolean remover(int numeroDeCadastro) {
		Modelo modelo = new Modelo();
		modelo.setNumeroModelo(numeroDeCadastro);
		return repositorio.remover(modelo);
	}

	public IteratorModelo buscaComParametros(String campoEscolhido,
			String valorEscolhido) {
		return null;
	}

	public IteratorModelo buscarTodos() {
		return null;
	}

}
