package aeronave;

import java.sql.Date;


import aeronave.exception.CodigoInvalidoException;

public class Aeronave {
	private String codigo;
	private String modelo;
	private String companhia;
	private Date ultimaManutencao;
	private int horasDeVoo;

	Aeronave(String codigo, String modelo, String companhia, Date ultimaManutencao, int horasDeVoo) throws CodigoInvalidoException {
		this.codigo = codigo.toUpperCase();
		this.modelo = modelo;
		this.companhia = companhia.toUpperCase();
		this.ultimaManutencao = ultimaManutencao;
		this.horasDeVoo = horasDeVoo;
		checarCodigo();
	}

	private void checarCodigo() throws CodigoInvalidoException {
		if(codigo.length() != 6) throw new CodigoInvalidoException(codigo + " no  um cdigo vlido!");
		if(codigo.charAt(2) != '-') throw new CodigoInvalidoException(codigo + " no  um cdigo vlido!");
		for(int i = 0; i < codigo.length(); i++) {
			if(i != 2 && codigo.charAt(i) == '-') throw new CodigoInvalidoException(codigo + " no  um cdigo vlido!");
		}
	}

	public String getCodigo() {
		return codigo;
	}

	public String getModelo() {
		return modelo;
	}

	public String getCompanhia() {
		return companhia;
	}

	public Date getUltimaManutencao() {
		return ultimaManutencao;
	}

	public int getHorasDeVoo() {
		return horasDeVoo;
	}
}
