package fachada;

import java.io.File;
import java.io.IOException;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.SQLException;

import javax.swing.ImageIcon;

import aeronave.Aeronave;
import aeronave.IteratorAeronave;
import aeronave.NegocioAeronave;
import aeronave.exception.ArquivoMuitoGrandeException;
import aeronave.exception.CodigoExistenteException;
import aeronave.exception.CodigoInexistenteException;
import aeronave.exception.CodigoInvalidoException;
import aeronave.exception.ImagemInvalidaException;

public class Fachada {
	NegocioAeronave negocioAeronave;
	Connection conexaoBD;
	public Fachada() throws SQLException{
		this.conexaoBD = DriverManager.getConnection(
				"jdbc:oracle:thin:@itapissuma.cin.ufpe.br:1521:dbdisc",
				"g081if685_eq07", "gabycoptero");
		this.negocioAeronave = new NegocioAeronave(conexaoBD);
	}
	

	public void inserirAeronave(String codigo, String modelo, String companhia, Date ultimaManutencao, int horasDeVoo, File img) throws SQLException, CodigoInvalidoException, ImagemInvalidaException, IOException, CodigoExistenteException, ArquivoMuitoGrandeException {
		negocioAeronave.inserirAeronave(codigo, modelo, companhia, ultimaManutencao, horasDeVoo, img);
	}
	
	public ImageIcon getFoto(String codigo) throws SQLException {
		return negocioAeronave.getFoto(codigo);
	}

	public void removerAeronave(String codigo) throws SQLException, CodigoInvalidoException, CodigoInexistenteException {
		negocioAeronave.removerAeronave(codigo);
	}

	public Aeronave consultarCodigo(String codigo) throws SQLException, CodigoInvalidoException {
		return negocioAeronave.consultarCodigo(codigo);
	}
	
	public IteratorAeronave consultarCompanhia(String companhia) throws SQLException, CodigoInvalidoException {
		return negocioAeronave.consultarCompanhia(companhia);
	}
	
	public IteratorAeronave consultarModelo(String modelo) throws SQLException, CodigoInvalidoException {
		return negocioAeronave.consultarModelo(modelo);
	}
	
	
}
