package gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.sql.Date;
import java.sql.SQLException;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.filechooser.FileFilter;

import aeronave.Aeronave;
import aeronave.IteratorAeronave;
import aeronave.exception.ArquivoMuitoGrandeException;
import aeronave.exception.CodigoExistenteException;
import aeronave.exception.CodigoInexistenteException;
import aeronave.exception.CodigoInvalidoException;
import aeronave.exception.ImagemInvalidaException;

import fachada.Fachada;

public class GUIPrincipal extends JFrame{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JLabel background;
	private ImageIcon fundo;
	private JMenu menuAeronave;
	private JMenuItem itemAeronaveInserir , itemAeronaveRemover , itemAeronaveConsultar;
	private JPanel panel;
	Fachada fachada;

	public GUIPrincipal() {
		try {
			fachada = new Fachada();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		this.setTitle("Projeto GDI - Trfego Areo");
		this.fundo = new ImageIcon("imagens/bg.gif");
		this.background = new JLabel(this.fundo);
		this.background.setSize(600, 400);
		this.setLocation(320,120);
		this.setSize(600,400);
		this.panel = new JPanel();
		this.iniciarPanel();
		this.setContentPane(this.panel);

		this.iniciarItensDosMenus();
		this.iniciarMenus();
		this.iniciarBarraDeMenus();

		this.setVisible(true);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);  

		this.itemAeronaveInserir.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae2){
				mostrarPanelInserir();
				setContentPane(panel);
			}
		});

		this.itemAeronaveRemover.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae2){
				mostrarPanelRemover();
				setContentPane(panel);
			}
		});

		this.itemAeronaveConsultar.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae2){
				mostrarPanelConsultar();
				setContentPane(panel);
			}
		});
	}

	private JPanel iniciarPanel(){

		this.panel.removeAll();
		this.panel.setLayout(null);
		this.panel.setSize(600,400);
		this.panel.setLocation(0,19);
		this.panel.add(this.background);
		return panel;
	}

	private void mostrarPanelInserir(){
		this.iniciarPanel();

		JLabel l1 = new JLabel("Preencha os campos abaixo para inserir uma aeronave:");
		l1.setFont(new Font("ARIAL" , 1, 12));
		l1.setLocation(10, 30);
		l1.setSize(370, 20);
		panel.add(l1);

		JLabel l2 = new JLabel("Cdigo:");
		l2.setFont(new Font("ARIAL" , 1, 12));
		l2.setLocation(10, 80);
		l2.setSize(70, 20);
		panel.add(l2);

		JLabel l3 = new JLabel("Modelo:");
		l3.setFont(new Font("ARIAL" , 1, 12));
		l3.setLocation(250, 80);
		l3.setSize(70, 20);
		panel.add(l3);

		JLabel l4 = new JLabel("Data da ltima manuteno:");
		l4.setFont(new Font("ARIAL" , 1, 12));
		l4.setLocation(10, 130);
		l4.setSize(250, 20);
		panel.add(l4);

		JLabel l5 = new JLabel("(dd/mm/aaaa)");
		l5.setForeground(Color.yellow);
		l5.setFont(new Font("ARIAL" , 1, 12));
		l5.setLocation(320, 130);
		l5.setSize(100, 20);
		panel.add(l5);

		JLabel l6 = new JLabel("Horas de vo:");
		l6.setFont(new Font("ARIAL" , 1, 12));
		l6.setLocation(10, 180);
		l6.setSize(100, 20);
		panel.add(l6);

		JLabel l7 = new JLabel("Companhia:");
		l7.setFont(new Font("ARIAL" , 1, 12));
		l7.setLocation(250, 180);
		l7.setSize(100, 20);
		panel.add(l7);

		JLabel l8 = new JLabel("Imagem:");
		l8.setFont(new Font("ARIAL" , 1, 12));
		l8.setLocation(10, 230);
		l8.setSize(100, 20);
		panel.add(l8);

		final JComboBox c1 = new JComboBox(new String[] {"Gol", "Varig", "TAM", "Ocean Air" });
		c1.setLocation(335, 180);
		c1.setSize(140, 20);
		panel.add(c1);

		final JTextField txt1 = new JTextField();
		txt1.setLocation(70, 80);
		txt1.setSize(160,20);
		panel.add(txt1);

		final JTextField txt2 = new JTextField();
		txt2.setLocation(315, 80);
		txt2.setSize(160,20);
		panel.add(txt2);

		final JTextField txt3 = new JTextField();
		txt3.setLocation(185, 130);
		txt3.setSize(120,20);
		panel.add(txt3);

		final JTextField txt4 = new JTextField();
		txt4.setLocation(105, 180);
		txt4.setSize(130,20);
		panel.add(txt4);

		final JTextField txt5 = new JTextField();
		txt5.setLocation(70, 230);
		txt5.setSize(360,20);
		txt5.setEditable(false);
		panel.add(txt5);

		JButton bt1 = new JButton("Inserir");
		bt1.setSize(150,20);
		bt1.setLocation(10, 280);
		panel.add(bt1);

		JButton bt2 = new JButton("Localizar...");
		bt2.setSize(120,20);
		bt2.setLocation(450, 230);
		panel.add(bt2);

		bt1.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae2){
				String codigo = txt1.getText();
				String modelo = txt2.getText();
				String ultimanutencao = txt3.getText();
				String horasVoo = txt4.getText();

				String path = txt5.getText();
				int comp = c1.getSelectedIndex();
				String companhia = null;
				if(comp == 0) companhia = "Gol";
				else if(comp == 1) companhia = "Varig";
				else if(comp == 2) companhia = "TAM";
				else if(comp == 3) companhia = "Ocean Air";
				int horasDeVoo = 0;
				Date ultimaManutencao = null;

				if(codigo.length() == 0){
					new GUIJanelaMensagem("Preencha o campo cdigo" , "Alerta do sistema", 2);
				}
				else if(codigo.length() > 6){
					new GUIJanelaMensagem("O cdigo deve conter no mximo 6 caracteres", "Erro : Codigo invlido" , 0);
				}
				else if(modelo.length() == 0){
					new GUIJanelaMensagem("Preencha o campo modelo", "Alerta do sistema" , 2);
				}
				else if(modelo.length() > 20){
					new GUIJanelaMensagem("O modelo deve conter no mximo 20 caracteres", "Erro : Modelo invlido" , 0);
				}
				else if(!verificaData(ultimanutencao) && ultimanutencao.length() > 0){
					new GUIJanelaMensagem("A data deve estar no formato dd/mm/aaaa", "Erro: Data invlida" , 0);
				}
				/*
				else if(path.length() < 5 && path.length() > 0){
					new GUIJanelaMensagem("A extenso imagem deve ser .JPG ou .GIF", "Erro" , 0);
				}*/
				else if(path.length() > 5 && !verificaImagem(path.substring(path.length() - 4 , path.length()))){
					new GUIJanelaMensagem("A extenso imagem deve ser .JPG ou .GIF", "Erro: Formato invlido" , 0);
				}
				else {
					if(horasVoo.length() > 0){
						horasDeVoo = Integer.parseInt(horasVoo);
					}
					if(verificaData(ultimanutencao) && ultimanutencao.length() > 0 && ultimanutencao.length() < 11){
						String dt = ultimanutencao.substring(6,10) + "-" + ultimanutencao.substring(3,5) + "-" + ultimanutencao.substring(0,2);
						ultimaManutencao = Date.valueOf(dt);
					}
					File img = null; 
					if(path.length() > 0) img = new File(path);
					try{
						fachada.inserirAeronave(codigo, modelo, companhia, ultimaManutencao, horasDeVoo, img);
						new GUIJanelaMensagem("Dados inseridos com sucesso", "OK" , 1);

					}
					catch(NumberFormatException e){
						new GUIJanelaMensagem("Insira um nmero vlido no campo horas de vo" , "Erro : Nmero invlido", 0);
					}
					catch(IllegalArgumentException e){
						new GUIJanelaMensagem("Insira uma data vlida", "Erro: Data invlida" , 0);
					}
					catch (SQLException e) {
						new GUIJanelaMensagem("Problema ao acessar o banco de dados", "Erro" , 0);
					} catch (CodigoInvalidoException e) {
						new GUIJanelaMensagem("O cdigo digitado  invalido", "Erro: Cdigo invlido" , 0);
					} catch (ImagemInvalidaException e) {
						new GUIJanelaMensagem("A imagem deve ser no mximo 300x200", "Erro: Imagem invlida" , 0);
					} catch (IOException e) {
						new GUIJanelaMensagem("Problema ao acessar o arquivo de imagem", "Erro" , 0);
					} catch (CodigoExistenteException e) {
						new GUIJanelaMensagem("J existe uma aeronave com o cdigo digitado", "Erro: Cdigo j existente" , 0);
					} catch (ArquivoMuitoGrandeException e) {
						new GUIJanelaMensagem("A imagem  muito grande", "Erro" , 0);
					}
				}
				/*txt1.setText("");
				txt2.setText("");
				txt3.setText("");
				txt4.setText("");
				txt5.setText("");*/


			}
		});

		bt2.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae2){
				JFileChooser fc = new JFileChooser();
				fc.setFileFilter(new FileFilter() {  
					public boolean accept(File f) {  
						String nome = f.getName().toLowerCase();  
						return nome.endsWith(".jpg") || nome.endsWith(".gif") || f.isDirectory();  
					}  
					public String getDescription() {  
						return "Arquivos de Imagem (*.jpg, *.gif)";  
					}  
				});
				fc.showOpenDialog(null);
				File diretorio = fc.getSelectedFile();
				if(diretorio != null){
					txt5.setText(diretorio.getPath());	
				}
			}
		});

		panel.add(this.background);
	}

	private void mostrarPanelConsultar(){
		this.iniciarPanel();

		JLabel l1 = new JLabel("Escolha o tipo de consulta a ser realizado:");
		l1.setFont(new Font("ARIAL" , 1, 12));
		l1.setLocation(10, 30);
		l1.setSize(370, 20);
		panel.add(l1);

		JLabel l2 = new JLabel("Informe o cdigo:");
		l2.setFont(new Font("ARIAL" , 1, 12));
		l2.setLocation(10, 80);
		l2.setSize(170, 20);
		panel.add(l2);


		JLabel l3 = new JLabel("Informe o modelo:");
		l3.setFont(new Font("ARIAL" , 1, 12));
		l3.setLocation(10, 130);
		l3.setSize(170, 20);
		panel.add(l3);


		JLabel l4 = new JLabel("Escolha a companhia:");
		l4.setFont(new Font("ARIAL" , 1, 12));
		l4.setLocation(10, 180);
		l4.setSize(170, 20);
		panel.add(l4);

		final JComboBox c1 = new JComboBox(new String[] {"Gol", "Varig", "TAM", "Ocean Air" });
		c1.setLocation(150, 180);
		c1.setSize(160, 20);
		panel.add(c1);

		final JComboBox c2 = new JComboBox(new String[] {"Sem resultados para exibir." });
		c2.setLocation(10, 230);
		c2.setSize(300, 20);
		panel.add(c2);

		final JTextField txt1 = new JTextField();
		txt1.setLocation(150, 80);
		txt1.setSize(160,20);
		panel.add(txt1);

		final JTextField txt2 = new JTextField();
		txt2.setLocation(150, 130);
		txt2.setSize(160,20);
		panel.add(txt2);

		JButton bt1 = new JButton("Consulta por cdigo");
		bt1.setSize(180,20);
		bt1.setLocation(340, 80);
		panel.add(bt1);


		bt1.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae2){
				String codigo = txt1.getText();
				try {
					if(codigo.length() == 0){
						new GUIJanelaMensagem("Preencha o campo cdigo" , "Alerta do sistema", 2);
					}
					else if(codigo.length() > 6){
						new GUIJanelaMensagem("O cdigo deve conter no mximo 6 caracteres", "Erro : Codigo invlido" , 0);
					}
					else{
						Aeronave aero = fachada.consultarCodigo(codigo);
						if(aero != null) {
							c2.removeAllItems();
							c2.addItem(aero.getCodigo());
						}
						else{
							c2.removeAllItems();
							c2.addItem("Sem resultados para exibir.");
						}
					}
				} catch (SQLException e) {
					new GUIJanelaMensagem("Problema ao acessar o banco de dados", "Erro" , 0);
				} catch (CodigoInvalidoException e) {
					new GUIJanelaMensagem("O cdigo digitado  invalido", "Erro: Cdigo invlido" , 0);
				}
			}
		});

		JButton bt2 = new JButton("Consulta por modelo");
		bt2.setSize(180,20);
		bt2.setLocation(340, 130);
		panel.add(bt2);

		bt2.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae2){
				String modelo = txt2.getText();
				try {
					if(modelo.length() == 0){
						new GUIJanelaMensagem("Preencha o campo modelo", "Alerta do sistema" , 2);
					}
					else if(modelo.length() > 20){
						new GUIJanelaMensagem("O modelo deve conter no mximo 20 caracteres", "Erro : Modelo invlido" , 0);
					}
					else{
						IteratorAeronave iaero = fachada.consultarModelo(modelo);
						c2.removeAllItems();
						if(!iaero.hasNext()){
							c2.addItem("Sem resultados para exibir.");
						}
						else{
							while(iaero.hasNext()){
								Aeronave aero = iaero.next();
								c2.addItem(aero.getCodigo());
							}
						}
					}
				} catch (SQLException e) {
					new GUIJanelaMensagem("Problema ao acessar o banco de dados", "Erro" , 0);
				} catch (CodigoInvalidoException e) {
					new GUIJanelaMensagem("O cdigo digitado  invalido", "Erro: Cdigo invlido" , 0);
				}
			}
		});

		JButton bt3 = new JButton("Consulta por companhia");
		bt3.setSize(180,20);
		bt3.setLocation(340, 180);
		panel.add(bt3);

		bt3.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae2){
				int comp = c1.getSelectedIndex();
				String companhia = null;
				if(comp == 0) companhia = "Gol";
				else if(comp == 1) companhia = "Varig";
				else if(comp == 2) companhia = "TAM";
				else if(comp == 3) companhia = "Ocean Air";
				try {
					IteratorAeronave iaero = fachada.consultarCompanhia(companhia);
					c2.removeAllItems();					
					if(!iaero.hasNext()){
						c2.addItem("Sem resultados para exibir.");
					}
					else{
						while(iaero.hasNext()){
							Aeronave aero = iaero.next();
							c2.addItem(aero.getCodigo());
						}
					}
				} catch (SQLException e) {
					new GUIJanelaMensagem("Problema ao acessar o banco de dados", "Erro" , 0);
				} catch (CodigoInvalidoException e) {
					new GUIJanelaMensagem("O cdigo digitado  invalido", "Erro: Cdigo invlido" , 0);
				}
			}
		});

		JButton bt4 = new JButton("Exibir detalhes");
		bt4.setSize(180,20);
		bt4.setLocation(340, 230);
		panel.add(bt4);

		bt4.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae2){
				String s = (String) c2.getSelectedItem();
				if(!s.equals("Sem resultados para exibir.")){
					try {
						Aeronave aero = fachada.consultarCodigo(s);
						if(fachada.getFoto(s) != null){
							ImageIcon img = fachada.getFoto(s);
							new GUIExibirDetalhes(aero, img);
						}
						else{
							new GUIExibirDetalhes(aero, null);
						}
					} catch (SQLException e) {
					} catch (CodigoInvalidoException e) {
					}
				}
			}
		});

		panel.add(this.background);
	}

	private void mostrarPanelRemover(){
		this.iniciarPanel();

		JLabel l1 = new JLabel("Informe o cdigo da aeronave a ser removida:");
		l1.setFont(new Font("ARIAL" , 1, 12));
		l1.setLocation(10, 30);
		l1.setSize(370, 20);
		panel.add(l1);

		JLabel l2 = new JLabel("Cdigo:");
		l2.setFont(new Font("ARIAL" , 1, 12));
		l2.setLocation(10, 80);
		l2.setSize(170, 20);
		panel.add(l2);

		final JTextField txt1 = new JTextField();
		txt1.setLocation(80, 80);
		txt1.setSize(160,20);
		panel.add(txt1);

		JButton bt1 = new JButton("Remover do banco de dados");
		bt1.setSize(200,20);
		bt1.setLocation(280, 80);
		panel.add(bt1);

		bt1.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae2){
				String codigo = txt1.getText();
				if(codigo.length() == 0){
					new GUIJanelaMensagem("Preencha o campo cdigo" , "Alerta do sistema", 2);
				}
				else if(codigo.length() > 6){
					new GUIJanelaMensagem("O cdigo deve conter no mximo 6 caracteres", "Erro : Codigo invlido" , 0);
				}
				else{
					try {
						fachada.removerAeronave(codigo);
						new GUIJanelaMensagem("Aeronave removida com sucesso!", "OK", JOptionPane.INFORMATION_MESSAGE);
					} catch (SQLException e) {
						new GUIJanelaMensagem("Problema ao acessar o banco de dados", "Erro" , 0);
					}
					//txt1.setText("");
					catch (CodigoInvalidoException e) {
						new GUIJanelaMensagem("O Cdigo inserido no  vlido!", "Erro: Cdigo Invlido", JOptionPane.WARNING_MESSAGE);
					} catch (CodigoInexistenteException e) {
						new GUIJanelaMensagem("Cdigo Inexistente!", "Erro", JOptionPane.ERROR_MESSAGE);
					}
				}
			}
		});

		panel.add(this.background);
	}
	private void iniciarBarraDeMenus(){
		JMenuBar menu = new JMenuBar();
		menu.add(menuAeronave);
		menu.setSize(100,15);
		this.setJMenuBar(menu);
	}
	private void iniciarMenus(){
		menuAeronave = new JMenu("Aeronave");
		menuAeronave.setFont(new Font("ARIAL" , 1, 10));
		this.menuAeronave.add(itemAeronaveInserir);
		this.menuAeronave.add(itemAeronaveConsultar);
		this.menuAeronave.add(itemAeronaveRemover);
	}
	private void iniciarItensDosMenus(){
		this.itemAeronaveInserir = new JMenuItem("Inserir Aeronave");
		this.itemAeronaveInserir.setFont(new Font("ARIAL" , 1, 10));
		this.itemAeronaveConsultar = new JMenuItem("Consultar Aeronave");
		this.itemAeronaveConsultar.setFont(new Font("ARIAL" , 1, 10));
		this.itemAeronaveRemover = new JMenuItem("Remover Aeronave");
		this.itemAeronaveRemover.setFont(new Font("ARIAL" , 1, 10));
	}
	private boolean verificaImagem(String formato){
		formato = formato.toUpperCase();
		if(formato.equals(".JPG") || formato.equals(".GIF")){
			return true;
		}
		return false;
	}
	private boolean verificaData(String data){
		if(data.length() ==  10){
			if(ehNumero(data.charAt(0)) && ehNumero(data.charAt(1)) && ehNumero(data.charAt(3)) && ehNumero(data.charAt(4)) && ehNumero(data.charAt(6)) && ehNumero(data.charAt(7)) && ehNumero(data.charAt(8)) && ehNumero(data.charAt(9))){
				if(data.charAt(2) == '/' && data.charAt(5) == '/') return true;
			}
		}
		return false;
	}
	private boolean ehNumero(char c){
		if(c == '0' || c == '1' || c == '2' || c == '3' || c == '4' || c == '5' || c == '6' || c == '7' || c == '8' || c == '9') return true;
		return false;
	}
}